#!/bin/bash
S_NAME=tomcat6
DB_NAME=rcd
C_DIR=$(cd "$(dirname "$0")"; pwd)
RCD_BIN=/usr/rcd/bin
DB_PORT_L=5432
DB_PORT_C=5433

cd $C_DIR

#include files
. ./common.json

tmpf=/tmp/_sqlout.tmp


mode=`$RCD_BIN/fetchServerState.sh|grep -i message|awk -F'=' '{print $2}'|awk '{print $1}'`
role=`$RCD_BIN/fetchServerRole.sh|grep -i message|awk -F'=' '{print $2}'|awk '{print $1}'`
if [ "$mode" = "Cluster" -a "$role" = "0" ]; then
   port=$DB_PORT_C
else
   port=$DB_PORT_L
fi

#psql -d rcd -p $port -c "select b.name,a.* from lb_seat_info a, lb_classroom b where a.classroom_id=b.id order by a.id;" > $tmpf
su - postgres<<EOF
   psql -d rcd -p $port -c "select b.name,a.*,c.os_type,c.rcc_os_version,c.product_model from lb_seat_info a left join lb_classroom b on a.classroom_id=b.id left join rcd_seat c on  a.terminal_mac=c.mac_address  order by a.id; " > $tmpf
EOF

index=0
RE=`cat $tmpf|sed '1,2d;N;$d;P;D'`
line=`cat $tmpf|wc -l`
((line=line-4))
echo "["

while read item
do
  ((index++))
  vmHostName=`echo $item|awk -F'|' '{print $5}'`
  vmIp=`echo $item|awk -F'|' '{print $12}'`
  vmMac=`echo $item|awk -F'|' '{print $11}'`
  vmMask=`echo $item|awk -F'|' '{print $21}'`
  vmGateway=`echo $item|awk -F'|' '{print $22}'`
  vmDns=`echo $item|awk -F'|' '{print $23}'`
  vmUsername=`echo $item|awk -F'|' '{print $25}'`
  vmPassword=`echo $item|awk -F'|' '{print $26}'`
  
  tmHostName=`echo $item|awk -F'|' '{print $15}'`
  tmNetType=`echo $item|awk -F'|' '{print $16}'`
  tmIp=`echo $item|awk -F'|' '{print $6}'`
  tmMac=`echo $item|awk -F'|' '{print $7}'`
  tmMask=`echo $item|awk -F'|' '{print $17}'`
  tmGateway=`echo $item|awk -F'|' '{print $18}'`
  tmDns=`echo $item|awk -F'|' '{print $19}'`
  tmResolutionRadio=`echo $item|awk -F'|' '{print $20}'`
  tmOsVersion=`echo $item|awk -F'|' '{print $37}'`
  tmOsType=`echo $item|awk -F'|' '{print $36}'`
  tmProductModel=`echo $item|awk -F'|' '{print $38}'`
  e_json vmHostName "$vmHostName" vmIp "$vmIp" vmMac "$vmMac" vmMask "$vmMask" vmGateway "$vmGateway" vmDns "$vmDns" vmUsername "$vmUsername" vmPassword "$vmPassword" tmHostName "$tmHostName" tmNetType "$tmNetType" tmIp "$tmIp" tmMac "$tmMac" tmMask "$tmMask" tmGateway "$tmGateway" tmDns "$tmDns" tmResolutionRadio "$tmResolutionRadio" tmOsVersion "$tmOsVersion" tmOsType "$tmOsType" tmProductModel "$tmProductModel"
  if [ $index -lt $line ]; then
    echo -n ","
  fi
done<<<"${RE}"


echo "]"

