define(function(require, exports, module) {	
	require('ztree');
	require('bootstrapTable');
	require('bootstrapTableCn');
	var modal = require("../../js/modal");
	var global = require("../../js/global");
	
	// 现在,收集与自动升级，共用一个tftp服务器
	//global.tftpServerIns.start({
 //       root: global.jsUtil.getDataRootPath(),
 //       host: "0.0.0.0",
 //       port: 69,
 //   });
    
 //   // ftp服务器启动
 //   global.ftpServiceIns.start({
 //       root: jsUtil.getDataRootPath(),
 //       port: 21
    //   });  
    
    // 这里初始化了所有的服务，以及预先建立了所有文件夹
    global.envIns.init();
    
	
	//设备管理页面的全局变量
	var devNameToModify = "";
	var curDevInfo = [];	//存储当前设备列表全部的设备信息。作用：1、编辑设备时直接查询该变量不再读数据库；2、添加设备时判断有无重名。
	var curSelectedNode = undefined;
	var curRightClickNode = undefined;
	var addFlag = 1;	//1表示添加设备，0表示编辑设备
	var setting = {
		view: {
			showLine: false,
			showIcon: false,
			selectedMulti: false,
			dblClickExpand: false,
			autoCancelSelected: false,
			addDiyDom: addDiyDom
		},
		data: {
			simpleData: {
				enable: true
			}
		},
		callback: {
			beforeClick: beforeClick,
			onClick: onClick,
			beforeRightClick: beforeRightClick,
			onRightClick: onRightClick
		}
	};

	function addDiyDom(treeId, treeNode) {
		var spaceWidth = 10;
		var switchObj = $("#" + treeNode.tId + "_switch");
		icoObj = $("#" + treeNode.tId + "_ico");
		switchObj.remove();
		icoObj.before(switchObj);
        var spaceStr = "<span style='display: inline-block;width:" + (spaceWidth * treeNode.level)+ "px'></span>";
		switchObj.before(spaceStr);
	}

	function beforeClick(treeId, treeNode) {
		console.log(treeNode);
		if (treeNode.level == 0) {
			var zTree = $.fn.zTree.getZTreeObj("deviceAttrTree");
			zTree.expandNode(treeNode);
			return false;
		} else {
			var parentNode = treeNode;
			while (parentNode.level != 0) {
				parentNode = parentNode.getParentNode();
			}
			var parentObj = $("#" + parentNode.tId + "_a");
			if (!parentObj.hasClass('selectParentNode')) {
				$(".selectParentNode").removeClass('selectParentNode');
				parentObj.addClass('selectParentNode');
			}
			
			showDeviceGroupName(treeId, treeNode);
			return true;
		}
	}
	
	function onClick(event, treeId, treeNode, clickFlag) {
		curSelectedNode = treeNode;
		addDevInfoToTable(searchDeviceByGroupId(treeNode.id));
		return true;
	}
	
	function beforeRightClick(treeId, treeNode) {	//beforeRightClick没有参数event, 无法获取到当前鼠标点击的位置
		return true;
	}
	
	function onRightClick(event, treeId, treeNode) {
		curRightClickNode = treeNode;
		$("#editNodeModal div.modal-dialog").css("left", event.clientX);
		$("#editNodeModal div.modal-dialog").css("top", event.clientY);
		$("#editNodeModal").modal('show');
		return true;
	}
	
	function showDeviceGroupName(treeId, treeNode) {
		var html = "";
		var title = "";
		var treeNodeName = [];
		var parentNode = treeNode;
		for (var i = 0; i <= treeNode.level; i++) {
			treeNodeName.push(parentNode.name);
			parentNode = parentNode.getParentNode();
		}
		for (var i = (treeNodeName.length - 1); i >= 0; i--) {
			if (i != 0) {
				html += treeNodeName[i] + '<span class="textSeparator"> / </span>';
				title += treeNodeName[i] + ' / ';
			} else {
				html += treeNodeName[i];
				title += treeNodeName[i];
			}
		}
		$("#deviceGroupName").html(html);
		$("#deviceGroupName").attr("title", title);
	}
	
	function getAndShowDevInfo() {
	    function queryDevInfoCallback(error, result) {
	        curDevInfo = result;
	        if (error == null) {
	            addDevInfoToTable(result);
	        } else {
	            alert(undefined, "读取设备数据失败！");
	        }
	    }
	    global.devicesIns.getDeviceConfigInfoAll(queryDevInfoCallback);
	}
	
	function addDevInfoToTable(devInfo) {
	    for (var i = 0; i < devInfo.length; ++i) {	        
	        if (devInfo[i].protocal == "serial") {
	            devInfo[i].conne_type = devInfo[i].protocal;
	            devInfo[i].host_com = devInfo[i].comNum;
	            devInfo[i].port = devInfo[i].baudrate;
	        } else {
	            devInfo[i].conne_type = devInfo[i].protocal;
	            devInfo[i].host_com = devInfo[i].host;
	            devInfo[i].port = devInfo[i].port;
	        }
	        
	        if (devInfo[i].groupName === null || devInfo[i].groupName === undefined || devInfo[i].groupName === '') {
	            devInfo[i].groupName = "未分组";
	        }

	        // 更新 curDevInfo
	        for (var j = 0; j < curDevInfo.length; ++j) {
	            if (curDevInfo[j].deviceName == devInfo[i].deviceName) {
	                curDevInfo[j].groupName = devInfo[i].groupName;
	                break;
	            }
	        }
	    }
	    
		$('#deiveManageTable').bootstrapTable('load', devInfo);
	    return;
	}
	
	function operateStyle(value) {
	    return '<div class="table-btn edit" style="width: 50px;">编辑</div>';
	}
	
	function searchDeviceByGroupId(selectGroupId) {
	    curDevInfo = global.devicesIns.queryLinkInfoByGroupIdFromMem(null);
	    var groupDevice = global.devicesIns.queryLinkInfoByGroupIdFromMem(selectGroupId);
	    return groupDevice;
	}
	exports.searchDeviceByGroupId = searchDeviceByGroupId;

	function protocol_type_onchange(value) {
		if (value === "serial") {
	        $("#telnet_para_group").hide();
	        $("#serial_para_group").show();
	        $("#band_rate").val("115200");
	    } else if (value === "telnet") {
	        $("#telnet_para_group").show();
	        $("#serial_para_group").hide();
	        $("#loca_port").val("23");
	    } else if (value === "SSH") {
	        $("#telnet_para_group").show();
	        $("#serial_para_group").hide();
	        $("#loca_port").val("22");
	    }
	}
	
	function queryAllSubGroupsCbk(err, rows, select_id) {
    	if (err != null) {
    		alert(undefined, "查询分组信息失败！");
    		return;
    	}
//    	console.log(rows);
    	for (var i = 0; i < rows.length; i++) {
    		var val = rows[i].groupId + ':' + rows[i].groupName;
    		var text = rows[i].groupName;
    		global.addOption(val, text, select_id);
    	}
    }
	exports.queryAllSubGroupsCbk = queryAllSubGroupsCbk;
	
	function editDeviceClick(row, index) {		
	    if (curDevInfo === null) {
	        return;
	    }
	    console.log(row);
	    addFlag = 0;
	    $("#group_name").show();
	    $('#addDeviceModal').modal('show');
	    for (var i = 0; i < curDevInfo.length; ++i) {
	        if (curDevInfo[i].deviceName == row.deviceName) {
	        	$("#addDeviceModal .modal-title").text("修改设备");
	            devNameToModify = curDevInfo[i].deviceName;
	            setDevInfoToModify(curDevInfo[i]);
	            break;
	        }
	    }
	}
	
	function setDevInfoToModify(row) {
	    //添加串口
	    var port_id = "port";
	    $("#" + port_id).children().remove();
	    function getComListCallback(data) {	    	
	        if (data.length === 0) {
	            global.addOption("无", "无", port_id);
	        } else {
	            data = data.sort();
	            for (var i = 0; i < data.length; ++i) {
	            	global.addOption(data[i], data[i], port_id);
	            }
	        }

//	        $("#group_name").val(row.groupName);
	        $("#loca_dev_name").val(row.deviceName);
	        $("#protocol_type").val(row.protocal);
	        protocol_type_onchange(row.protocal);
	        
	        if (row.username != "") {
	            $("#loca_username").val(row.username);
	        } else {
	            $("#loca_username").val("");
	        }
	        if (row.password != "") {
	            $("#loca_pwd").val(row.password);
	        } else {
	            $("#loca_pwd").val("");
	        }
	        if (row.enablePassword != "" && row.enablePassword != undefined) {
	            $("#loca_enable_pwd").val(row.enablePassword);
	        } else {
	            $("#loca_enable_pwd").val("");
	        }
	        
	        $("#code_option").val(row.encoding);
	        if (row.encoding === "utf8") {
	            $("#code_option").val(row.encoding.toUpperCase() + ",通用编码");
	        } else if (row.encoding === "gb2312") {
	            $("#code_option").val(row.encoding.toUpperCase() + ",中文编码");
	        }
	        
	        if (row.protocal === "serial") {
	            var serialNum = row.comNum;
	            $("#band_rate").val(row.baudrate);
	            var existFlag = 0;
	            for (var i = 0; i < data.length; ++i) {
	                if (serialNum === data[i]) {
	                    $("#port").val(serialNum);
	                    existFlag = 1;
	                    break;
	                }
	            }
	            if (existFlag === 0) {
	                alert(undefined, "当前设备不存在端口号:" + serialNum);
	            }
	        } else {
	            $("#loca_ip_addr").val(row.host);
	            $("#loca_port").val(row.port);
	        }
	    }
	    global.deviceConfIns.getComList(getComListCallback);
        
        //查询分组，添加到select下，并显示当前分组
		var group_id = "group_name";
     	$("#" + group_id).children().remove();
     	
     	function queryAllSubGroupsCbkCurPage(err, rows, select_id) {
        	if (err != null) {
        		alert(undefined, "查询分组信息失败！");
        		return;
        	}
//        	console.log(rows);
        	for (var i = 0; i < rows.length; i++) {
        		var val = rows[i].groupId + ':' + rows[i].groupName;
        		var text = rows[i].groupName;
        		global.addOption(val, text, select_id);
        	}
        	
    	    // 显示当前分组
//            var groupIds = [];
//            $("#group_name option").each(function() {
//            	groupIds.push($(this).val());
//            });
//            for (var i = 0; i < groupIds.length; i++) {
//            	console.error(groupIds[i]);
//            	if (groupIds[i].split(':')[0] == row.groupId) {
//            		$("#group_name").val(groupIds[i]);
//            		break;
//            	}
//            }
            for (var i = 0; i < rows.length; i++) {
            	if (rows[i].groupId == row.groupId) {
            		$("#group_name").val(rows[i].groupId + ':' + rows[i].groupName);
            		break;
            	}
        	}
        }
	    global.devicesIns.queryAllSubGroups(group_id, queryAllSubGroupsCbkCurPage);
	}
	
	function get_connect_param(addFlag) {
	    var dev_name = $("#loca_dev_name").val();
	    var conne_type = $("#protocol_type").val();
	    var encoding = $("#code_option").val();
	    var parameter = {
	        deviceName : dev_name,
	        protocal : conne_type,
	        encoding : encoding.split(',')[0].toLowerCase() //* 外部传入按照 toUpperCase+中文说明 设置文字的
	    };
	    
//	    console.error(addFlag);
	    if (addFlag != null) {
	    	if (addFlag === 1) {
		    	parameter.groupId = curSelectedNode.id;
		    } else if (addFlag === 0) {
		    	var groupId = $('#group_name').val();
//		    	console.log(groupId);
		    	groupId = groupId.split(':')[0];
		    	parameter.groupId = groupId;
		    }
	    }
	    
	    var user_name = $("#loca_username").val();
	    var pwd = $("#loca_pwd").val();
	    parameter.username = user_name;
	    parameter.password = pwd;
	    
	    if (conne_type === "serial") {
	        var selected_com_num = $('#port option:selected').text();
	        if (selected_com_num === "" || selected_com_num === "无") {
	            alert(undefined, "请选择正确的端口号");
	            return false;
	        }
	        var selected_band_rate = $('#band_rate option:selected').text();
	        var enable_pwd = $("#loca_enable_pwd").val();
	        
	        parameter.comNum = selected_com_num;
	        parameter.baudrate = selected_band_rate;
	        parameter.enablePassword = enable_pwd;
	    } else {
	        var ip = $("#loca_ip_addr").val();
	        if (!isIpOk(ip)) { //判断ip地址是否合法
	            alert(undefined, "您输入IP格式不正确，必须是000.000.000.000格式");
	            return false;
	        }

	        if (conne_type == "SSH") {
	            if ($("#loca_username").val() == "") { //* 用 user_name 或者 pwd 更合适些
	                alert(undefined, "SSH连接时用户名不能为空！");
	                return false;
	            }
	            if ($("#loca_pwd").val() == "") {
	                alert(undefined, "SSH连接时密码不能为空！");
	                return false;
	            }
	        }

	        var port = $("#loca_port").val();
	        var enable_pwd = $("#loca_enable_pwd").val();
	        
	        parameter.host = ip;
	        parameter.port = port;
	        parameter.containShell = true;
	        parameter.enablePassword = enable_pwd;

//	        if (conne_type !== "http" && conne_type !== "https") {
//	            parameter.enablePassword = enable_pwd;
//	        }
	    }
	    return parameter;
	}
	exports.get_connect_param = get_connect_param;
	
	function queryAllGroupsCallback(err, rows) {
//		console.log(err);
//		console.log(rows);
		if (err != null) {
			alert(undefined, "查询客户分组信息出错！");
			return;
		}				
		var zNodes = [];
		for (var i = 0; i < rows.length; i++) {
			var tmp_zNodes = {};
			tmp_zNodes.id = rows[i].groupId;
			tmp_zNodes.pId = rows[i].parentId;
			tmp_zNodes.name = rows[i].groupName;
			if (rows[i].open == "true") {
				tmp_zNodes.open = true;
			}
			zNodes.push(tmp_zNodes);
		}
		var treeObj = $("#deviceAttrTree");
		$.fn.zTree.init(treeObj, setting, zNodes);
		
//		// 更新树时需初始化变量
//		curSelectedNode = undefined;
//		curRightClickNode = undefined;
	}
	
	function init() {
		initWindowEvent();
		initPageStatistic();
		initVariable();
		initTree();
		initTable();
		initEvent();
		initDom();
		resize();
		initGlobalEvent();
		
		function initWindowEvent() {
			window.operateStyle = operateStyle;
			window.operateEvents = {
			    'click .edit': function (e, value, row, index) {
			    	editDeviceClick(row, index);
			    }
			};
			window.protocol_type_onchange = protocol_type_onchange;
		}
		function initPageStatistic() {
			statRecordEle("deviceManage#deviceManage");
		}
		function initVariable() {
			devNameToModify = "";
			curDevInfo = [];	//存储当前设备列表全部的设备信息。作用：1、编辑设备时直接查询该变量不再读数据库；2、添加设备时判断有无重名。
			curSelectedNode = undefined;
			curRightClickNode = undefined;
			addFlag = 1;	//1表示添加设备，0表示编辑设备
			setting = {
				view: {
					showLine: false,
					showIcon: false,
					selectedMulti: false,
					dblClickExpand: false,
					autoCancelSelected: false,
					addDiyDom: addDiyDom
				},
				data: {
					simpleData: {
						enable: true
					}
				},
				callback: {
					beforeClick: beforeClick,
					onClick: onClick,
					beforeRightClick: beforeRightClick,
					onRightClick: onRightClick
				}
			};
		}
		function initTree() {			
			global.devicesIns.queryAllGroups(queryAllGroupsCallback);
		}
		function initTable() {
			$('#deiveManageTable').bootstrapTable({
		        data: []
		    });
			
			$(".fixed-table-body").addClass('custom-scroll');
			$("#deiveManageTable").show();
			
			getAndShowDevInfo();
		}
        function initEvent() {
			$('#addUserModal').on('show.bs.modal', function() {
				$("#userName").val("");
			});
			
			$('#addGroupModal').on('show.bs.modal', function() {
				$("#groupName").val("");
			});
			
			$("#addUserModal .btn-confirm").click(function() {
				var userName = $("#userName").val();
				if (userName == '' || userName == null) {
					return;
				}				
				var params = {};
				params.groupName = userName;
				params.open = "true";
				global.devicesIns.InsertAndUpdateGroupIntoDb(params, InsertAndUpdateGroupIntoDbCbk);
				
				function InsertAndUpdateGroupIntoDbCbk(res) {
					if (res != null) {
						alert(undefined, "添加客户失败！");
						return;
					}
					global.devicesIns.queryAllGroups(queryAllGroupsCallback);
//					var zTree = $.fn.zTree.getZTreeObj("deviceAttrTree");
//					var newNode = {};
//					newNode.name = userName;
//					zTree.addNodes(null, newNode);
				}
			});
			
			$("#addGroupModal .btn-confirm").click(function() {
//				console.log(curRightClickNode);
				var groupName = $("#groupName").val();
				if (groupName == '' || groupName == null) {
					return;
				}
//				//如果当前选中的节点跟当前要新增子节点的节点是同一节点，去掉curSelectedNode样式
//				if (curRightClickNode.name == $(".curSelectedNode span:last-child").text()) {
//					$(".curSelectedNode").removeClass('curSelectedNode');
//				}
//				var zTree = $.fn.zTree.getZTreeObj("deviceAttrTree");
//				var newNode = {name:"新增节点"};
//				zTree.addNodes(curRightClickNode, newNode);
				var params = {};
				var userName = $("#groupName").val();
				params.groupName = userName;
				params.parentId = curRightClickNode.id;
				global.devicesIns.InsertAndUpdateGroupIntoDb(params, InsertAndUpdateGroupIntoDbCbk);
				
				function InsertAndUpdateGroupIntoDbCbk(res) {
					if (res != null) {
						alert(undefined, "添加客户失败！");
						return;
					}
					global.devicesIns.queryAllGroups(queryAllGroupsCallback);
				}
			});
			
			$('#addDevBtn').click(function() {
				if (curSelectedNode == undefined) {
					alert(undefined, "请选中某个分组后再在该分组上添加设备！");
					return;
				}
				addFlag = 1;
				$("#addDeviceModal").modal('show');
				$("#addDeviceModal .modal-title").text("添加设备");
		        $("#loca_dev_name").val("");
		        $("#loca_ip_addr").val("");
		        $("#loca_port").val("23");
		        $("#loca_username").val("");
		        $("#loca_pwd").val("");
		        $("#loca_enable_pwd").val("");
		        $("#protocol_type").val("telnet");
		        $("#code_option").val("UTF8,通用编码");
		        $("#group_name").hide();
		        protocol_type_onchange("telnet");
		        
		        //添加串口
		        var select_id = "port";
		        $("#" + select_id).children().remove();
		        function getComListCallback(data) {
		            if (data.length === 0) {
		            	global.addOption("无", "无", select_id);
		            } else {
		                data = data.sort();
		                for (var i = 0; i < data.length; ++i) {
		                	global.addOption(data[i], data[i], select_id);
		                }
		            }
		        }
		        global.deviceConfIns.getComList(getComListCallback);
		    });
			
			$("#addDeviceModal .btn-confirm").click(function() {
				var dev_name = $("#loca_dev_name").val();
			    if (dev_name === "") {
			        alert(undefined, "请填写设备名称");
			        return;
			    }
			    
			    //1.判断设备名是否为空且是否唯一，不唯一则提示 2.将数据插入到数据库 3.重新获取数据并显示在界面中
			    if (curDevInfo !== undefined) {
			        for (var i = 0; i < curDevInfo.length; ++i) {
			            if (dev_name !== devNameToModify && dev_name === curDevInfo[i].deviceName) {
			                alert(undefined, "设备名称已经存在，请重新输入");
			                return;
			            }
			        }
			    }
			    
			    var parameter = get_connect_param(addFlag);
			    if (parameter === false) {
			    	return;
			    }
			    console.error(parameter);
			    
			    $("#addDeviceModal").modal('hide');
			    
			    if (addFlag === 1) { //添加的时候直接插入
			        function insertDevinfoCallback(error, result) {
			            if (error === null) { //插入正确
			                addDevInfoToTable(searchDeviceByGroupId(curSelectedNode.id));
			            } else {
			                alert(undefined, "数据插入失败!");
			            }
			        }
			        global.devicesIns.addDeviceLink(parameter, insertDevinfoCallback);
			    } else if (addFlag === 0) { //修改设备信息
			        var dataToModify;
			        for (var i = 0; i < curDevInfo.length; ++i) {
			            if (devNameToModify === curDevInfo[i].deviceName) {
			                dataToModify = curDevInfo[i];
			                break;
			            }
			        }
			        dataToModify.groupId = parameter.groupId;
			        dataToModify.deviceName = parameter.deviceName;
			        dataToModify.protocal = parameter.protocal;
			        dataToModify.username = parameter.username;
			        dataToModify.password = parameter.password;
			        dataToModify.encoding = parameter.encoding;
			        if (parameter.protocal === "serial"){
			            dataToModify.comNum = parameter.comNum;
			            dataToModify.baudrate = parameter.baudrate;
			            dataToModify.enablePassword = parameter.enablePassword;
			        } else {
			            dataToModify.host = parameter.host;
			            dataToModify.port = parameter.port;
			            if (parameter.protocol != "http" && parameter.protocol != "https") {
			                dataToModify.enablePassword = parameter.enablePassword;
			            }
			            dataToModify.containShell = true;
			        } 
//			        console.log(parameter);
//			        console.log(dataToModify);
			        if (parameter.deviceName !== devNameToModify) { //修改了设备名，则先删除再插入
			            //将设备名字传递给后台去删除数据，再重新获取数据并显示 todo
			            function delOneDevCallback(error) {
			                if (error !== null) {
			                    alert(undefined, "修改失败!");
			                } else { //删除成功之后再插入
			                    function insertDevinfoCallback(error, result) {
			                        if (error === null) { //更新正确
			                        	if (curSelectedNode != undefined) { //有选中节点			                        		
					                		addDevInfoToTable(searchDeviceByGroupId(curSelectedNode.id));
					                	} else { //没有选中节点
//					                		console.error("设备设备设备设备");
//			    							console.error(searchDeviceByGroupId(null));
					                		addDevInfoToTable(searchDeviceByGroupId(null));
					                	}
			                        } else {
			                            alert(undefined, "信息修改失败!");
			                        }
			                    }
			                    global.devicesIns.addDeviceLink(dataToModify, insertDevinfoCallback);
			                }
			            }
			            //将设备名字传递给后台去改变状态这个字段，再重新获取数据并显示 
			            //获取选中的设备参数
			            var devNames = [];
			            devNames.push(devNameToModify);
			            global.devicesIns.deleteDeviceLinkByDeviceName(devNames, delOneDevCallback);
			        } else {
			            function updateDevinfoCallback(error, result) {
			                if (error === null) { //更新正确
			                	if (curSelectedNode != undefined) { //有选中节点
			                		addDevInfoToTable(searchDeviceByGroupId(curSelectedNode.id));
			                	} else { //没有选中节点
			                		addDevInfoToTable(searchDeviceByGroupId(null));
			                	}
			                } else {
			                    alert(undefined, "信息修改失败!");
			                }
			            }
			            global.devicesIns.updateDeviceLink(dataToModify, updateDevinfoCallback);
			        }
			    }
			});
			
			$('#deleteDevBtn').click(function() {
				var deleteDev = $("#deiveManageTable").bootstrapTable('getSelections');
				if (deleteDev.length == 0) {
					alert(undefined, '请至少选择一台设备！');
					return;
				}
				
				alert(undefined, "确认要删除设备吗？", function() {
//			        curStatus = changeDevStatus(curStatus, 'init'); //* XXX 这里假定后台删除的时候会自动断开连接，包括connecting和connected、closing对象

			        //将设备名字传递给后台去删除数据，再重新获取数据并显示 todo
			        function delDevCallback(error) {
			            if (error === null) {
			            	if (curSelectedNode != undefined) {
			            		addDevInfoToTable(searchDeviceByGroupId(curSelectedNode.id));
			            	} else {
			            		addDevInfoToTable(searchDeviceByGroupId(null));
			            	}
			            } else {
			                alert(undefined, "删除失败!");
			            }
			        }
			        var devNames = [];
			        var devInfos = $("#deiveManageTable").bootstrapTable('getSelections');
			        for (var i = 0; i < devInfos.length; ++i) {
			            devNames.push(devInfos[i].deviceName);
			        }
			        global.devicesIns.deleteDeviceLinkByDeviceName(devNames, delDevCallback);
			    }, true);
			});
			
			$('#editNodeModal .addNode').click(function() {
				if (curRightClickNode.level != 0) {
					alert(undefined, "只能在根节点下添加分组!");
					return;
				}
				$("#addGroupModal").modal('show');
			});
			
			$('#editNodeModal .deleteNode').click(function() {
//				$("#editNodeModal").modal('hide');
//				var zTree = $.fn.zTree.getZTreeObj("deviceAttrTree");
//				zTree.removeNode(curRightClickNode);
				console.log(curRightClickNode);
				alert(undefined, "确定要删除该分组及其该分组下的所有设备吗？", function() {
					var group = {};
					group.groupId = curRightClickNode.id;
					global.devicesIns.deleteGroup(group, deleteGroupCbk);
					
					function deleteGroupCbk(err) {
						if (err != null) {
							alert(undefined, "删除分组失败！");
							return;
						}
						global.devicesIns.queryAllGroups(queryAllGroupsCallback);
						if (curSelectedNode == undefined) {	//没有选中节点就删除
//							console.error("节点节点节点");
//							console.error(searchDeviceByGroupId(null));
							addDevInfoToTable(searchDeviceByGroupId(null));
						} else {
							if (curSelectedNode.id == curRightClickNode.id || curSelectedNode.pId == curRightClickNode.id) { //当前删除的节点包含当前选中的节点
								curSelectedNode = undefined;
								$("#deviceGroupName").html("");
								$("#deviceGroupName").attr("title", "");
								
								addDevInfoToTable(searchDeviceByGroupId(null));
							} else {
								addDevInfoToTable(searchDeviceByGroupId(curSelectedNode.id)); //可以不写，不会有问题。
							}
						}
					}
				}, true);
			});
			
			$("#batchImportModalBtn").click(function() {
				var selectConfFile = $('#selectConfFile');
				selectConfFile.unbind('change');
				selectConfFile.change(function(evt) {    	
//			    	console.log($(this).val());
					$("#loadingConfModal").modal('show');
			        function importDevicesCb(error, succ, fail) {
//			        	console.log(error);
//			        	console.log(succ);
//			        	console.log(fail);
			        	
			        	if (error != null) {
			        		$("#loadingConfModal").modal('hide');
			        		$("#loadConfFailModal").modal('show');
			        		setTimeout(function() {
			        			$("#loadConfFailModal").modal('hide');
			        		}, 1000);
			        		return;
			        	}
			        	
			        	$("#loadingConfModal").modal('hide');
			        	initTree();
			    		initTable();			    		
			    		$("#loadConfSuccessModal").modal('show');
			    		setTimeout(function() {
			    			$("#loadConfSuccessModal").modal('hide');
		        		}, 1000);
			        }
			        
			        var filePath = $(this).val();
//			        console.log(filePath);
			    	global.devicesIns.importDevices(filePath, importDevicesCb);
			    	
			        $(this).val("");
			    });
				selectConfFile.trigger('click');
			});
		}
		function initDom() {
			$('#addUserModal').modal({
				backdrop: 'static',
				show: false
			});
			$('#addDeviceModal').modal({
				backdrop: 'static',
				show: false
			});
			$('#loadingConfModal').modal({
				backdrop: 'static',
				show: false
			});
			
//			//查询分组，并添加到select下
//			var group_id = "group_name";
//	     	$("#" + group_id).children().remove();
//		    global.devicesIns.queryAllSubGroups(group_id, queryAllSubGroupsCbk);
		    
		    //添加下载模板路径
		    var path = global.jsUtil.getRootPath() + '/db/device_import.xlsx';
		    $("#downloadConfBtn").attr('href', path);
		}
		function resize() {
			var client_h = document.documentElement.clientHeight;
			var head_h = $(".main_menu").height();
			var body_h = client_h - head_h;

			$('#deiveManageTable').bootstrapTable('resetView', {height : body_h - 5});
		}
		function initGlobalEvent() {
			global.exitPageCallback.exitFun = function () {
				return true;
			}
		}
	}
	exports.init = init;
	
//	function addTestData() {
//		$('#deiveManageTable').bootstrapTable({
//	        data: curDevInfo
//	    });
//		
//		$(".fixed-table-body").addClass('custom-scroll');
//		$("#deiveManageTable").show();
//		$('#deiveManageTable').bootstrapTable('showLoading');
//		$('#deiveManageTable').bootstrapTable('resetView', {height:550});
//		
//		var tmp_curDevInfo = {};
//		for (var i = 0; i < 15; i++) {
//			tmp_curDevInfo.deviceName = "192.168.23.191";
//			tmp_curDevInfo.deviceModel = "S2910C-24GT2XS-P-E";
//			tmp_curDevInfo.ipAddress = "192.168.23.191";
//			tmp_curDevInfo.softVersion = "S2910_RGOS 11.4(1)B1P1, Release(03142218)";
//			curDevInfo.push(tmp_curDevInfo);
//		}
//		$('#deiveManageTable').bootstrapTable('hideLoading');
//		$('#deiveManageTable').bootstrapTable('load', curDevInfo);
//	}
});
