define(function(require, exports, module) {
	require('datetimepicker');
	require('datetimepickerCn');
	var global = require("../../js/global");
	var jGlobal = require("./faultDiagGlobal");
	var upload = require("./upload");
	var curUploadParams = {};
	
	function operateStyle(value) {	    
	    return '<div>' +
	    			'<div class="table-btn upload" style="float: left; width: 50px;">上传</div>' +
	    			'<div class="table-btn view" style="float: left; width: 50px; margin-left: 5px;">查看</div>' +
			   '</div>';
	}
	
	function uploadDiagLogInfo(row, index) {
//		console.log(row);
		
		var path = global.nwPath.resolve(global.tftpOperateInstance.queryLogFilePath(), row.logId);
		jGlobal.faultDiag.diagSavePath = path;
		
		curUploadParams.deviceName = row.deviceName;
		curUploadParams.ruleName = row.ruleName;
		curUploadParams.logParams = {};
		curUploadParams.logParams.deviceIp = row.deviceIp;
		curUploadParams.logParams.deviceType = row.deviceType;
		
		$("#uploadModal").modal('show');
	}
	
	function viewDiagLogInfo(row, index) {
//		console.log(row);
	    var path = global.nwPath.resolve(global.tftpOperateInstance.queryLogFilePath(), row.logId);
	    global.jsUtil.openDir(path);
	}
	
	function getDiagLogInfo() {		
		function queryAllLogsCb(err, rows) {
			if (err != null) {
				alert(undefined, "读取日志信息失败！");
				return;
			}
			
			var diagInfo = [];
			for (var i = 0; i < rows.length; i++) {
				var tmpDiagInfo = [];
				tmpDiagInfo.logId = rows[i].logId;
				tmpDiagInfo.diagData = rows[i].diagTime;
				tmpDiagInfo.deviceModel = rows[i].deviceType;
				tmpDiagInfo.ipAddr = rows[i].deviceIp;
				tmpDiagInfo.faultType = rows[i].ruleName;
				tmpDiagInfo.savePath = rows[i].savePath;
				tmpDiagInfo.deviceName = rows[i].deviceName;
				tmpDiagInfo.deviceIp = rows[i].deviceIp;
				tmpDiagInfo.deviceType = rows[i].deviceType;
				tmpDiagInfo.ruleName = rows[i].ruleName;
				diagInfo.push(tmpDiagInfo);				
			}
			
			$('#diagLogTable').bootstrapTable('load', diagInfo);
		}
		global.logDbIns.queryAllLogs(queryAllLogsCb);
	}
	
	function init() {
		initWindowEvent();
		initPageStatistic();
		initVariable();
		initTable();
		initEvent();
		initDom();
		resize();
		initGlobalEvent();
		
		function initWindowEvent() {
			window.operateStyle = operateStyle;
			window.operateEvents = {
			    'click .upload': function (e, value, row, index) {
			    	uploadDiagLogInfo(row, index);
			    },
			    'click .view': function (e, value, row, index) {
			    	viewDiagLogInfo(row, index);
			    }
			};
		}
		function initPageStatistic() {
			statRecordEle("faultDiag#diagLog");
		}
		function initVariable() {
			curUploadParams = {};
		}
		function initTable() {
			$('#diagLogTable').bootstrapTable({
		        data: []
		    });
			
			$(".fixed-table-body").addClass('custom-scroll');
			$("#diagLogTable").show();
			
			getDiagLogInfo();
		}
		function initEvent() {
			$('#selectTimeModal').on('hidden.bs.modal', function() {
				$("#startTime").val("");
				$("#endTime").val("");
			});
			
			$("#selectTimeModal .btn-confirm").click(function() {
				var startTime = $("#startTime").val();
				var endTime = $("#endTime").val();				
//				console.log(startTime);
//				console.log(endTime);
				
				function queryLogsByTimeCb(err, rows) {
					if (err != null) {
						alert(undefined, "读取日志信息失败！");
						return;
					}
					
					var diagInfo = [];
					for (var i = 0; i < rows.length; i++) {
						var tmpDiagInfo = [];
						tmpDiagInfo.logId = rows[i].logId;
						tmpDiagInfo.diagData = rows[i].diagTime;
						tmpDiagInfo.deviceModel = rows[i].deviceType;
						tmpDiagInfo.ipAddr = rows[i].deviceIp;
						tmpDiagInfo.faultType = rows[i].ruleName;
						tmpDiagInfo.savePath = rows[i].savePath;
						diagInfo.push(tmpDiagInfo);				
					}
					
					$('#diagLogTable').bootstrapTable('load', diagInfo);
				}
				var params = {};
				params.startTime = startTime;
				params.endTime = endTime;
				global.logDbIns.queryLogsByTime(params, queryLogsByTimeCb);
			});
			
			$('#uploadModal').on('show.bs.modal', function() {
				$('#uploadModal .modal-body').load("./faultDiagMenu/html/upload.html", function() {
					console.log(curUploadParams);
					
					var productType = global.tftpOperateInstance.checkProductType(curUploadParams.deviceName);
					var emailSubject = $("#uploadFaultId").text() + " + " + productType.deviceType + " + " + curUploadParams.ruleName + "。";					
					upload.setEmailSubject(emailSubject);
					upload.setUploadParams(curUploadParams);
				});
			});
			
			$('#uploadModal .claim>span').click(function() {
				$('#claimModal').modal('show');
			});
		}
		function initDom() {
			$('#selectTimeModal').modal({
				backdrop: 'static',
				show: false
			});
			
			$('#diagLogStartTime').datetimepicker({
		        language: 'zh-CN',
		        weekStart: 1,
		        todayBtn:  1,
				autoclose: 1,
				todayHighlight: 1,
				startView: 2,
				minView: 2,
				forceParse: 0
		    });
			
			$('#diagLogEndTime').datetimepicker({
		        language: 'zh-CN',
		        weekStart: 1,
		        todayBtn:  1,
				autoclose: 1,
				todayHighlight: 1,
				startView: 2,
				minView: 2,
				forceParse: 0
		    });
		}
		function resize() {
			var client_h = document.documentElement.clientHeight;
			var head_h = $(".main_menu").height();
			var body_h = client_h - head_h;
			
			$('#diagLogTable').bootstrapTable('resetView', {height : body_h - 5});
		}
		function initGlobalEvent() {
			global.exitPageCallback.exitFun = function () {
				return true;
			}
		}
	}
	exports.init = init;
});