define(function (require, exports, module) {
    var global = require("../../js/global");
    
    var faultDiag = {};
    faultDiag.curStatus = "init";	// init -> connecting -> connected -> collect -> diagnosis -> closing -> init
    faultDiag.diagnoseId = ''; // 同一次诊断,升级,上传文件的faultDig相同
    faultDiag.collectDevName = [];
    faultDiag.collectType = undefined;
    faultDiag.typeName = undefined;
    faultDiag.rulePath = undefined;
    faultDiag.preconditionParams = {};
    faultDiag.cpuUsedLimit = 60;
    faultDiag.startTime_collect = 0;
    faultDiag.endTime_collect = 0;
    faultDiag.startTime_diag = 0;
    faultDiag.endTime_diag = 0;
    faultDiag.startTime_repair = 0;
    faultDiag.endTime_repair = 0;
    faultDiag.diagSavePath = undefined;
    faultDiag.diagnoseResult = [];
    faultDiag.diagCount = 0;
    faultDiag.totalWarnCount = 0;
    faultDiag.successCount = 0;
    faultDiag.manualCount = 0;
    faultDiag.tmpCollectPercent = 0;
    faultDiag.tmpDiagPercent = 0;
    faultDiag.flag = false;
    faultDiag.selectGroupName = undefined;
    faultDiag.portNameArray = [];
    faultDiag.autoRepairCmds = [];
    faultDiag.backRepairCmds = [];
    faultDiag.manualConfirmAdvice = [];
    faultDiag.uploadUserInfo = {};
    faultDiag.curSelectNode = {};
    
    faultDiag.isClickResolved = false;  //是否已点击过“解决”、“未解决”。若点击过，不再显示自服务率统计对话框；否则显示。（现在已无用）
    faultDiag.isLoadFromDiag = false;   //只收集，不显示自服务率对话框；先诊断后收集，显示自服务率对话框。
    faultDiag.isClickCancel = false;    //诊断时是否点击过强制取消。若点击过，不再显示自服务率统计对话框；否则显示。
    
    function changeDevStatus(cur, next) {
        console.log('[curStatus] change from ' + cur + ' to ' + next);
        return next;
    }
    function judgeDiagResultType(result) { //判断当前后台返回诊断结果是处理建议、已排查问题还是需协助判断
        if (result.level == "warn" && result.problems[0].checkIns != undefined) {
            result.level = "manual";
        }
        return result;
    }
    function showTime(startTime, endTime, span_min_time, span_sec_time) {
        var sec_time = parseInt((endTime - startTime) / 1000);
        if (sec_time >= 60) {
            var min_time = parseInt(sec_time / 60);
            sec_time = sec_time % 60;
            $(span_min_time).text(min_time);
            $(span_sec_time).text(sec_time);
        } else {
            $(span_min_time).text(0);
            $(span_sec_time).text(sec_time);
        }
    }
    
    function uploadInfoToCloud(param) {
        var uploadDiagDataAray = [];
        var uploadDiagData = {};
        var devInfo = global.devicesIns.getDeviceInfoByDeviceName(faultDiag.collectDevName[0]);
        var productLine = global.tftpOperateInstance.checkProductType(faultDiag.collectDevName[0]);
        //	    var zTree = $.fn.zTree.getZTreeObj("treeDemo");
        //	    var nodeList = zTree.getNodesByParamFuzzy("name", typeName);
        

        uploadDiagData.deviceSn = devInfo.seriaNo;
        uploadDiagData.deviceName = devInfo.deviceName;
        uploadDiagData.deviceIp = devInfo.host;
        uploadDiagData.deviceVersion = devInfo.softVer;
        uploadDiagData.deviceType = devInfo.deviceModel;
        uploadDiagData.ruleCode = global.transliteration.slugify(faultDiag.collectType);
        uploadDiagData.ruleName = faultDiag.collectType;
        uploadDiagData.subRuleCode = global.transliteration.slugify(faultDiag.typeName);
        uploadDiagData.subRuleName = faultDiag.typeName;
        uploadDiagData.diagnoseTime = global.moment().format('YYYY-MM-DD HH:mm:ss');
        uploadDiagData.duration = param.duration;
        uploadDiagData.diagnoseResult = param.actionResult;
        uploadDiagData.productLine = productLine.deviceType;
        
        
        
        //	    console.error(faultDiag.preconditionParams);
        //	    console.error(JSON.stringify(faultDiag.preconditionParams));
        
        if (param.curAction == "diagnosis") {
            uploadDiagData.isResolved = param.isResolved;
            uploadDiagData.argument = JSON.stringify(faultDiag.preconditionParams);
            
            //	        if (nodeList[0].manualDiag != undefined && nodeList[0].manualDiag == true) { //人工诊断已经不在这个页面
            //	        	uploadDiagData.hasProblem = true;
            //	        	uploadDiagData.manualDiagnose = true;
            //	        } else {
            if (faultDiag.totalWarnCount != 0) {
                uploadDiagData.hasProblem = true;
            } else {
                uploadDiagData.hasProblem = false;
            }
            uploadDiagData.manualDiagnose = false;
//	        }
        }
        
        console.log('in uploadInfoToCloud: groupId:', devInfo.groupId, ' func:', global.devicesIns.queryGroupInfoById);
        global.devicesIns.queryGroupInfoById(devInfo.groupId, function (err, rows) {
            var hasGroup = false;
            
            if (err == null && rows.length > 0) {
                hasGroup = true;

            }
            console.log('hasGroup:', hasGroup, ' rows:', JSON.stringify(rows));
            uploadDiagData.customer = (hasGroup == true ? rows[0].customer : '');
            uploadDiagData.subGroup = (hasGroup == true ? rows[0].subGroup : '');
            uploadDiagDataAray.push(uploadDiagData);
            //	    console.log(uploadDiagDataAray);
            statInfoIns.sendFaultDiagnose(uploadDiagDataAray, param.dataType);
        });


    }
    
    exports.faultDiag = faultDiag;
    exports.changeDevStatus = changeDevStatus;
    exports.judgeDiagResultType = judgeDiagResultType;
    exports.showTime = showTime;
    exports.uploadInfoToCloud = uploadInfoToCloud;
});