define(function(require, exports, module) {
	require('datetimepicker');
	require('datetimepickerCn');
	var global = require("../../js/global");
	
	function getDiagLogInfo() {		
		function queryAllLogsCb(err, rows) {
			if (err != null) {
				alert(undefined, "读取日志信息失败！");
				return;
			}
			
			console.log(rows);
			var uploadInfo = [];
			for (var i = 0; i < rows.length; i++) {
				var tmpUploadInfo = [];
				tmpUploadInfo.logId = rows[i].fileName;
				tmpUploadInfo.uploadData = rows[i].uploadTime;
				tmpUploadInfo.deviceModel = rows[i].deviceType;
				tmpUploadInfo.ipAddr = rows[i].deviceIp;
				tmpUploadInfo.faultType = rows[i].ruleName;
				tmpUploadInfo.savePath = rows[i].savePath;
				uploadInfo.push(tmpUploadInfo);				
			}
			
			$('#uploadLogTable').bootstrapTable('load', uploadInfo);
		}
		global.logUploadDbIns.queryAllLogs(queryAllLogsCb);
	}
	
	function init() {
		initWindowEvent();
		initPageStatistic();
		initTable();
		initEvent();
		initDom();
		resize();
		initGlobalEvent();
		
		function initWindowEvent() {

		}
		function initPageStatistic() {
			statRecordEle("faultDiag#diagLog");
		}
		function initTable() {
			$('#uploadLogTable').bootstrapTable({
		        data: []
		    });
			
			$(".fixed-table-body").addClass('custom-scroll');
			$("#uploadLogTable").show();
			
			getDiagLogInfo();
		}
		function initEvent() {
			$('#selectTimeModal').on('hidden.bs.modal', function() {
				$("#startTime").val("");
				$("#endTime").val("");
			});
			
			$("#selectTimeModal .btn-confirm").click(function() {
				var startTime = $("#startTime").val();
				var endTime = $("#endTime").val();				
//				console.log(startTime);
//				console.log(endTime);
				
				function queryLogsByTimeCb(err, rows) {
					if (err != null) {
						alert(undefined, "读取日志信息失败！");
						return;
					}
					console.log(rows);
					var uploadInfo = [];
					for (var i = 0; i < rows.length; i++) {
						var tmpUploadInfo = [];
						tmpUploadInfo.logId = rows[i].fileName;
						tmpUploadInfo.uploadData = rows[i].uploadTime;
						tmpUploadInfo.deviceModel = rows[i].deviceType;
						tmpUploadInfo.ipAddr = rows[i].deviceIp;
						tmpUploadInfo.faultType = rows[i].ruleName;
						tmpUploadInfo.savePath = rows[i].savePath;
						uploadInfo.push(tmpUploadInfo);				
					}
					
					$('#uploadLogTable').bootstrapTable('load', uploadInfo);
				}
				var params = {};
				params.startTime = startTime;
				params.endTime = endTime;
				global.logUploadDbIns.queryLogsByTime(params, queryLogsByTimeCb);
			});
		}
		function initDom() {
			$('#selectTimeModal').modal({
				backdrop: 'static',
				show: false
			});
			
			$('#diagLogStartTime').datetimepicker({
		        language: 'zh-CN',
		        weekStart: 1,
		        todayBtn:  1,
				autoclose: 1,
				todayHighlight: 1,
				startView: 2,
				minView: 2,
				forceParse: 0
		    });
			
			$('#diagLogEndTime').datetimepicker({
		        language: 'zh-CN',
		        weekStart: 1,
		        todayBtn:  1,
				autoclose: 1,
				todayHighlight: 1,
				startView: 2,
				minView: 2,
				forceParse: 0
		    });
		}
		function resize() {
			var client_h = document.documentElement.clientHeight;
			var head_h = $(".main_menu").height();
			var body_h = client_h - head_h;
			
			$('#uploadLogTable').bootstrapTable('resetView', {height : body_h - 5});
		}
		function initGlobalEvent() {
			global.exitPageCallback.exitFun = function () {
				return true;
			}
		}
	}
	exports.init = init;
});