define(function(require, exports, module) {
	var gui = window.require('nw.gui');
	var win = gui.Window.get();
	var fs = window.require("fs");
	var nwPath = window.require('path');
	var jsUtil = window.require('../../common/js/jsUtil');
	var moment = window.require("moment");
	var transliteration = window.require('transliteration');
	var Q = window.require("q");
	
	var devices = window.require("../../common/js/deviceLinkMgr");
	var devicesIns = new devices();
    var dbIns = devicesIns.getDbInstance();
    
    // 所有TFTP服务器的操作，都调用下面的类
    //var tftpServer = window.require('../../common/js/tftpServer');
    //var tftpServerIns = new tftpServer();
    
    //// 所有ftp服务器的操作，都调用下面的类
    //var ftpServer = window.require('../../common/js/ftpServer');
    //var ftpServiceIns = new ftpServer();
    
    var runningEnv = window.require("../../common/js/runningEnv");
    var envIns = new runningEnv();
	
	var tftpOperate = window.require("../../common/js/OneCollect");
	var tftpOperateInstance = new tftpOperate(devicesIns, dbIns, statInfoIns);
	
	var diagDirector = window.require("../../common/js/diagDirector");
	var diagDirectorIns = undefined;

	var deviceConf= window.require("../../common/js/deviceConf");   //动态调用，不需要静态包含
	var deviceConfIns = new deviceConf();

	var diagnosis = window.require("../../common/js/diagnosis");
	var diagnosisIns = new diagnosis();

	var diagFixer = window.require("../../common/js/diagFixer");
	var diagFixerIns = undefined;

	var diaRollbacker = window.require("../../common/js/diaRollbacker");
	var diaRollbackerIns = undefined;
	
	var logDb = window.require("../../common/js/diagLogDb"); 
	var logDbIns = new logDb(dbIns);
	
	var logUploadDb = window.require("../../common/js/diagUploadLogDb"); 
    var logUploadDbIns = new logUploadDb(dbIns);
    
    var offlineDbMgr = window.require('../../common/js/offlineDbMgr');

	var logger = window.require('../../common/js/Logger');
	var log = logger.getLogger('oneUpgrade');
	var uuid = window.require('node-uuid');
	var childProcess = window.require('child_process');
	
	var oneUpgrade = window.require("../../common/js/oneUpgrade");
	var oneUpgradeIns = new oneUpgrade(devicesIns);

	var cmdMigration = window.require("../../common/js/cmdMigration");
	var cmdMigrationIns = new cmdMigration();

	var configMgr = window.require("../../common/js/ConfigMgr");
	var configMgrIns = new configMgr();
	
	var childToolMgr = window.require("../../common/js/childToolMgr");
	var childToolMgrIns = new childToolMgr();
	
//	var restoreConnect = window.require('../../common/js/restoreConnect');
//    var restoreConnectIns = new restoreConnect();
	
	var restore = window.require('../../common/js/restore');
    var restoreIns = new restore(devicesIns);
	
	//当前点击的菜单id
	var curClickPageId = null;
	var pageIdToUrl = {
			".main_content" : {
				"#deviceManageMenu" : "./deviceManage/html/deviceManage.html",
				"#faultDiagMenu"    : "./faultDiagMenu/html/faultDiagMenu.html",
				"#logDiagMenu"      : "./logDiag/html/logDiag.html",
				"#oneUpgradeMenu"   : "./oneUpgrade/html/oneUpgradeMenu.html",
				"#softCenterMenu"   : "./softCenter/html/softCenter.html"
			},
			".selectDeviceContent" : {
				"#intelligentDiag"  : "./faultDiagMenu/html/selectDevice.html",
				"#diagLog"          : "./faultDiagMenu/html/diagLog.html",
				"#uploadLog"        : "./faultDiagMenu/html/uploadLog.html",
				"#diagLegend"       : "./faultDiagMenu/html/diagLegend.html"
			}
	};
	
	//在select中添加option
	function addOption(val, text, id) {
	    var $option = $("<option>");
	    if (val !== undefined) {
	    	$option.val(val);
	    }
	    $option.text(text);
	    $("#" + id).append($option);
	}
	
	var exitPageCallback = {};
	function enterPageCallback(curElement, nextPageUrl) {
		var permitExit = true;
		if (exitPageCallback.exitFun != undefined) {
			permitExit = exitPageCallback.exitFun();
		}
		if (permitExit) {
			$(curElement).load(nextPageUrl);
		}
	}
	
    exports.devicesIns = devicesIns;
    //exports.tftpServerIns = tftpServerIns;
    //exports.ftpServiceIns = ftpServiceIns;
    
    exports.envIns = envIns;

	exports.tftpOperateInstance = tftpOperateInstance;
	exports.fs = fs;
	exports.nwPath = nwPath;
	exports.jsUtil = jsUtil;	
	exports.moment = moment;
	exports.transliteration = transliteration;
	exports.diagDirector = diagDirector;
	exports.diagDirectorIns = diagDirectorIns;
	exports.deviceConfIns = deviceConfIns;
	exports.diagnosisIns = diagnosisIns;
	exports.diagFixer = diagFixer;
	exports.diagFixerIns = diagFixerIns;
	exports.diaRollbacker = diaRollbacker;
	exports.diaRollbackerIns = diaRollbackerIns;
	exports.logDbIns = logDbIns;
	exports.logUploadDbIns = logUploadDbIns;
	
	exports.log = log;
	exports.uuid = uuid;
	exports.childProcess = childProcess;
	exports.oneUpgradeIns = oneUpgradeIns;
	
	exports.win = win;
	exports.cmdMigrationIns = cmdMigrationIns;
	exports.configMgrIns = configMgrIns;
    exports.offlineDbMgr = offlineDbMgr;
	
	exports.childToolMgrIns = childToolMgrIns;
	
	exports.addOption = addOption;
	
	exports.exitPageCallback = exitPageCallback;
	exports.enterPageCallback = enterPageCallback;
	
	exports.curClickPageId = curClickPageId;
	exports.pageIdToUrl = pageIdToUrl;
	
	exports.Q = Q;
//	exports.restoreConnectIns = restoreConnectIns;
	exports.restoreIns = restoreIns;
});