define(function(require, exports, module) {
	var global = require("../../js/global");
	var jGlobal = require("./oneUpgradeGlobal");
	var deviceManage = require("../../deviceManage/js/deviceManage");
	
	function getAndShowDevInfo() {
	    function queryDevInfoCallback(error, result) {
	        if (error == null) {
	            addDevInfoToTable(result);
	        } else {
	            alert(undefined, "读取设备数据失败！");
	        }
	    }
	    global.devicesIns.getDeviceConfigInfoAll(queryDevInfoCallback);
	}
	
	function addDevInfoToTable(devInfo) {
//		console.log(devInfo);
	    for (var i = 0; i < devInfo.length; ++i) {	        
	        if (devInfo[i].protocal == "serial") {
	            devInfo[i].conne_type = devInfo[i].protocal;
	            devInfo[i].host_com = devInfo[i].comNum;
	            devInfo[i].port = devInfo[i].baudrate;
	        } else {
	            devInfo[i].conne_type = devInfo[i].protocal;
	            devInfo[i].host_com = devInfo[i].host;
	            devInfo[i].port = devInfo[i].port;
	        }
	        
	        if (devInfo[i].groupName === null || devInfo[i].groupName === undefined || devInfo[i].groupName === '') {
	            devInfo[i].groupName = "未分组";
	        }
	    }
	    
		$('#selectDeviceTable').bootstrapTable('load', devInfo);
	    return;
	}
	
	function operateStyle(value) {	
	    return '<div class="delete" style="cursor: pointer; font-size: 18px; color: #b8b8b8; margin-top: -5px;" data-toggle="tooltip" data-placement="right" title="点击将删除此设备">&times;</div>';
	}
	
	function deleteSelectedDev(row, index) {		
		var selectedDeviceCopy = jGlobal.oneUpgrade.selectedDevice;
		jGlobal.oneUpgrade.selectedDevice = [];
		for (var i = 0; i < selectedDeviceCopy.length; i++) {
			if (row.deviceName !== selectedDeviceCopy[i].deviceName) {
				jGlobal.oneUpgrade.selectedDevice.push(selectedDeviceCopy[i]);
			}
		}
		$('#selectedDeviceTable').bootstrapTable('load', jGlobal.oneUpgrade.selectedDevice);
		
		addCssForTable();
	}
	
	function addCssForTable() {
		$(".delete").hover(function() {
			$(this).css("color", "#f5224c");
	    }, function() {
	    	$(this).css("color", "#b8b8b8");
	    });
		
		$("[data-toggle='tooltip']").tooltip();
	}
	
	function initAndConnectAllDevice(result) {
		/* 初始化 */
		jGlobal.oneUpgrade.multiDevConnectStatus = {};
		jGlobal.oneUpgrade.connectDevNum = result.length;
		jGlobal.oneUpgrade.connectDevNum_getInfo = 0;
		jGlobal.oneUpgrade.connectDevNum_disconnect = 0;
		jGlobal.oneUpgrade.batchConnectFlag = true;
		jGlobal.oneUpgrade.multiDevRcmndVersion = {};
		
		for (var i = 0; i < result.length; i++) {
			jGlobal.oneUpgrade.multiDevConnectStatus[result[i].deviceName] = "init";
		}
//	    console.log(jGlobal.oneUpgrade.multiDevConnectStatus);
		
	    /* 连接所有设备，获取所有设备的设备型号、硬件版本、软件版本 */	    
	    for (var key in jGlobal.oneUpgrade.multiDevConnectStatus) {
	    	global.devicesIns.connectDeviceByDeviceName(key);
	    	// 当前正常状态init
	    	jGlobal.oneUpgrade.multiDevConnectStatus[key] = jGlobal.changeDevStatus(key, jGlobal.oneUpgrade.multiDevConnectStatus[key], 'connecting');
	    	jGlobal.oneUpgrade.connectDevNum_disconnect++;
	    }
	}
	
	// 当前正常状态init connecting connected closing
	function cancelConnectAllDev(msg) {
		jGlobal.oneUpgrade.connect_forcedCancelFlag = true;
    	var msg = " 正在断开所有设备的连接，请稍候…";
    	
		for (var key in jGlobal.oneUpgrade.multiDevConnectStatus) {
			if (jGlobal.oneUpgrade.multiDevConnectStatus[key] != "init") {  //处于init状态下断开连接无法收到deviceConnected消息
	    		global.devicesIns.closeDeviceLink(key);
	    		jGlobal.oneUpgrade.multiDevConnectStatus[key] = jGlobal.changeDevStatus(key, jGlobal.oneUpgrade.multiDevConnectStatus[key], 'closing');
	    	}
	    }
		alert(undefined, msg);
	}
	
	function determinRecommendedVersionCallback(res) {
//		console.error("--------------------------------------------");
//		console.error(res);
		
		jGlobal.oneUpgrade.multiDevRcmndVersion[res.addParams] = res.retParams;
		
		var objectTmp = {};
		if (res.retParams.softwareVersion == null || res.retParams.fileName == null) {
			jGlobal.oneUpgrade.multiDevUpgradeVersion[res.addParams] = "";
		} else {
			objectTmp.versionCode = res.retParams.softwareVersion;
			objectTmp.versionName = res.retParams.fileName;
			objectTmp.fileMd5 = res.retParams.fileMd5;
			jGlobal.oneUpgrade.multiDevUpgradeVersion[res.addParams] = objectTmp;
		}
		
		//获取完升级版本后，断开设备
		global.devicesIns.closeDeviceLink(res.addParams);
		jGlobal.oneUpgrade.multiDevConnectStatus[res.addParams] = jGlobal.changeDevStatus(res.addParams, jGlobal.oneUpgrade.multiDevConnectStatus[res.addParams], 'closing');
	}
	
	function init() {
		initWindowEvent();
		initPageStatistic();
		initVariable();
		removeGlobalEvent();
		initTable();
		initEvent();
		initDom();
		resize();
		initGlobalEvent();
		
		function initWindowEvent() {
			window.operateStyle = operateStyle;
			window.operateEvents = {
			    'click .delete': function (e, value, row, index) {
			    	deleteSelectedDev(row, index);
			    }
			};
			window.cancelConnectAllDev = cancelConnectAllDev;
		}
		function initPageStatistic() {
			statRecordEle("oneUpgrade#selectDevice");
		}
		function initVariable() {
			jGlobal.oneUpgrade.selectedDevice = [];
		}
		function removeGlobalEvent() {
			global.devicesIns.removeAllListeners("deviceConnected");
			global.devicesIns.removeAllListeners("deviceError");
			global.devicesIns.removeAllListeners("deviceDisconnected");
		}
		function initTable() {
			$('#selectDeviceTable').bootstrapTable({
		        data: [],
		        onCheck: function(row) {		        	
					if ($.inArray(row, jGlobal.oneUpgrade.selectedDevice) === -1) {
						jGlobal.oneUpgrade.selectedDevice.push(row);
						$("#selectedDevBtn").text("已选设备(" + jGlobal.oneUpgrade.selectedDevice.length + "台)");
					}
				},
				onCheckAll: function(rows) {
//					jGlobal.oneUpgrade.selectedDevice = []; 	//不能置空
//					jGlobal.oneUpgrade.selectedDevice = rows;
					for (var i = 0; i < rows.length; i++) {
						if ($.inArray(rows[i], jGlobal.oneUpgrade.selectedDevice) === -1) {
							jGlobal.oneUpgrade.selectedDevice.push(rows[i]);
						}
					}
					$("#selectedDevBtn").text("已选设备(" + jGlobal.oneUpgrade.selectedDevice.length + "台)");
				}
		    });
			$('#selectedDeviceTable').bootstrapTable({
		        data: []
		    });
			
			$(".fixed-table-body").addClass('custom-scroll');
			$("#selectDeviceTable").show();
			
			getAndShowDevInfo();
		}
		function initEvent() {
			$("#selectGroup").change(function() {		    	
		    	var groupId = $('#selectGroup').val();
		    	groupId = groupId.split(':')[0];
		    	if (groupId == "null") {
		    		groupId = null;
		    	}
		    	addDevInfoToTable(deviceManage.searchDeviceByGroupId(groupId));
		    });
			
			$('#selectedDeviceModal').on('show.bs.modal', function() {				
				$('#selectedDeviceTable').bootstrapTable('load', jGlobal.oneUpgrade.selectedDevice);
				$('#selectedDeviceTable').bootstrapTable('resetView', {height : 400});
				
				addCssForTable();
			});
			
			$('#selectedDeviceModal').on('hide.bs.modal', function () {
				$("#selectedDevBtn").text("已选设备(" + jGlobal.oneUpgrade.selectedDevice.length + "台)");
			});
			
			$("#batchConnect").click(function() {
			    if (jGlobal.oneUpgrade.selectedDevice.length == 0) {
			    	alert(undefined, "请至少选择一台设备！");
			    	return;
			    }
			    
			    $("#progress_connectAllDev").text('0%');
	            $("#progressBar_connectAllDev").css('width', '0%');
			    $("#dlg_connectAllDevProgress").modal('show');
			    
			    initAndConnectAllDevice(jGlobal.oneUpgrade.selectedDevice);
			});
			
//		    (当前正常状态是connecting)
		    global.devicesIns.on("deviceConnected", function(devName) {
		    	if (jGlobal.oneUpgrade.batchConnectFlag == true) { //批量连接时，连接上某台设备后，再断开当前连接的设备,修改状态为closing
//		        	console.error("deviceConnected", devName);
		        	
		        	if (jGlobal.oneUpgrade.multiDevConnectStatus[devName] != 'connecting') {
			    		return;
			    	} else {
			    		jGlobal.oneUpgrade.multiDevConnectStatus[devName] = jGlobal.changeDevStatus(devName, jGlobal.oneUpgrade.multiDevConnectStatus[devName], 'connected');
			    		
			    		var params = {};
			    		params.deviceName = devName;
			    		global.oneUpgradeIns.determinRecommendedVersion(params, determinRecommendedVersionCallback, devName); //连接上一台设备后，获取该设备的升级版本
			            
//			    		devicesIns.closeDeviceLink(devName);
//			    		multiDevConnectStatus[devName] = changeDevStatus(devName, multiDevConnectStatus[devName], 'closing');
//		    	    	
//			            return;
			    	}
		    	}
		    });
		    
		  // 1.设备端因为故障主动断开,会收到error消息,再收到disconnect消息; 2.连接设备无法连上,会收到error消息,再收到disconnect消息. (当前正常状态是connecting connected upgrade restart)
		    global.devicesIns.on("deviceError", function(res) {
		    	if (jGlobal.oneUpgrade.batchConnectFlag == true) {
//		    		console.error("deviceError", res.deviceName);

		        	if (jGlobal.oneUpgrade.multiDevConnectStatus[res.deviceName] == 'connecting') { //若当前设备处于connecting状态,说明该设备已尝试连接但无法连上,主动调用接口断开连接
						global.devicesIns.closeDeviceLink(res.deviceName);
						jGlobal.oneUpgrade.multiDevConnectStatus[res.deviceName] = jGlobal.changeDevStatus(res.deviceName, jGlobal.oneUpgrade.multiDevConnectStatus[res.deviceName], 'closing');       	    	                    
			    		return;
					} else if (jGlobal.oneUpgrade.multiDevConnectStatus[res.deviceName] == 'connected') { //原则上批量连接时不会处于该状态,批量升级时有可能处于该状态
						global.devicesIns.closeDeviceLink(res.deviceName);
						jGlobal.oneUpgrade.multiDevConnectStatus[res.deviceName] = jGlobal.changeDevStatus(res.deviceName, jGlobal.oneUpgrade.multiDevConnectStatus[res.deviceName], 'closing');
						return;
					} else if (jGlobal.oneUpgrade.multiDevConnectStatus[res.deviceName] == 'closing' || jGlobal.oneUpgrade.multiDevConnectStatus[res.deviceName] == 'init') {
						return;
					} else if (jGlobal.oneUpgrade.multiDevConnectStatus[res.deviceName] == 'upgrade') { //原则上批量连接时不会处于该状态,批量升级时有可能处于该状态
						jGlobal.oneUpgrade.multiDevConnectStatus[res.deviceName] = jGlobal.changeDevStatus(res.deviceName, jGlobal.oneUpgrade.multiDevConnectStatus[res.deviceName], 'closing');
						alert(undefined, '设备(' + res.deviceName + ')升级失败！错误信息: ' + res.errInfo);
						return;
					} else if (jGlobal.oneUpgrade.multiDevConnectStatus[res.deviceName] == 'restart') { //原则上批量连接时不会处于该状态,批量升级时有可能处于该状态
						jGlobal.oneUpgrade.multiDevConnectStatus[res.deviceName] = jGlobal.changeDevStatus(res.deviceName, jGlobal.oneUpgrade.multiDevConnectStatus[res.deviceName], 'closing');
						alert(undefined, '设备(' + res.deviceName + ')重启失败！错误信息: ' + res.errInfo);
						return;
					}
		    	}
		    });

		    /* 1.设备端因为故障主动断开,会收到error消息,再收到disconnect消息; 2.设备端正常断开,不发送error消息,只会接收到disconnect消息;
			   3.程序主动断开,不发送error消息,只会接收到disconnect消息(调用断开连接接口后都会置为closing);
			   4.连接设备无法连上,会收到error消息,再收到disconnect消息.
			   (当前正常状态是closing) (注:connecting upgrade restart原则上不会跑到, 因为升级或重启时若出错状态已被置为closing, connected在批量连接时，连接上设备后断开连接，状态置为closing;
			   	批量升级时，连接上设备后调用升级接口，状态置为upgrade) */
		    global.devicesIns.on("deviceDisconnected", function(devName) {
		    	if (jGlobal.oneUpgrade.batchConnectFlag == true) {
//		        	console.error("deviceDisconnected", devName);
		        	
		        	if (jGlobal.oneUpgrade.multiDevConnectStatus[devName] == "connecting") { //原则上不会跑到, 连接不上或程序主动断开状态均已被置为closing
			            return;
			    	} else if (jGlobal.oneUpgrade.multiDevConnectStatus[devName] == "connected") { //原则上不会跑到。批量连接时，连接上设备后断开连接，状态置为closing;批量升级时，连接上设备后调用升级接口，状态置为upgrade
			    		return;
			    	} else if (jGlobal.oneUpgrade.multiDevConnectStatus[devName] == "closing") {
		    			if (jGlobal.oneUpgrade.connect_forcedCancelFlag == false) { //说明该closing状态不是由强制取消改变的
		    				jGlobal.oneUpgrade.connectDevNum_getInfo++;
			    			
			    			/* 更新连接设备进度条 */
		        	        var percent = Math.floor((jGlobal.oneUpgrade.connectDevNum_getInfo / jGlobal.oneUpgrade.connectDevNum) * 100);
		        	        $("#progress_connectAllDev").text(percent + '%');
		    	            $("#progressBar_connectAllDev").css('width', percent + '%');
			    		}
		    			jGlobal.oneUpgrade.connectDevNum_disconnect--;
		    			jGlobal.oneUpgrade.multiDevConnectStatus[devName] = jGlobal.changeDevStatus(devName, jGlobal.oneUpgrade.multiDevConnectStatus[devName], 'init');
			    	} else if (jGlobal.oneUpgrade.multiDevConnectStatus[devName] == "upgrade") { //原则上不会跑到, 升级或重启时若出错状态已被置为closing
			    		jGlobal.oneUpgrade.multiDevConnectStatus[devName] = jGlobal.changeDevStatus(devName, jGlobal.oneUpgrade.multiDevConnectStatus[devName], 'init');
			    		alert(undefined, '设备(' + devName + ')升级失败！');
			    		return;
			    	} else if (jGlobal.oneUpgrade.multiDevConnectStatus[devName] == "restart") { //原则上不会跑到, 升级或重启时若出错状态已被置为closing
			    		jGlobal.oneUpgrade.multiDevConnectStatus[devName] = jGlobal.changeDevStatus(devName, jGlobal.oneUpgrade.multiDevConnectStatus[devName], 'init');
			    		alert(undefined, '设备(' + devName + ')重启失败！');
			    		return;
			    	} else if (jGlobal.oneUpgrade.multiDevConnectStatus[devName] == "init") {
			    		return;
			    	}
		        	
		        	/* 所有设备均已尝试过连接 */
		        	if (jGlobal.oneUpgrade.connectDevNum_getInfo == jGlobal.oneUpgrade.connectDevNum) {
		        		$("#dlg_connectAllDevProgress").modal('hide');
		        		setTimeout(function() {
//		        	    	$(".main_content").load("./oneUpgrade/html/selectVersion.html");
		        	    	
		        	    	var curElement = ".main_content", nextPageUrl = "./oneUpgrade/html/selectVersion.html";
		    				global.enterPageCallback(curElement, nextPageUrl);
		        	    }, 300);
		        	}
		        	
		        	console.error("connectDevNum_disconnect", jGlobal.oneUpgrade.connectDevNum_disconnect);
		        	/* 尝试过连接的设备均已断开连接 */
		        	if (jGlobal.oneUpgrade.connectDevNum_disconnect == 0) {
		        		jGlobal.oneUpgrade.batchConnectFlag = false;
		        		if (jGlobal.oneUpgrade.connect_forcedCancelFlag == true) {
		        			alert(undefined, "所有设备均已断开连接!", function() {
		        				jGlobal.oneUpgrade.connect_forcedCancelFlag = false;
		        			});
		        		}
		        	}
		    	}
		    });
		}
		function initDom() {
			$('#connectDevModal').modal({
				backdrop: 'static',
				show: false
			});
			$('#selectedDeviceModal').modal({
				backdrop: 'static',
				show: false
			});
			$('#dlg_connectAllDevProgress').modal({
				backdrop: 'static',
				show: false
			});
			
			//查询当前分组
			var select_id = "selectGroup";
	    	$("#" + select_id).children().remove();
	    	var $option = $("<option>");
	    	$option.val("null:全部分组");
	    	$option.text("全部分组");
	    	$("#" + select_id).append($option);
			global.devicesIns.queryAllSubGroups("selectGroup", deviceManage.queryAllSubGroupsCbk);
		}
		function resize() {
			var client_h = document.documentElement.clientHeight;
			var head_h = $(".main_menu").height();
			var body_h = client_h - head_h;
			
			$('#selectDeviceTable').bootstrapTable('resetView', {height : body_h - 55 - 65});
		}
		function initGlobalEvent() {
			global.exitPageCallback.exitFun = function () {
				removeGlobalEvent();
				return true;
			}
		}
	}
	exports.init = init;
});