define(function(require, exports, module) {
	var global = require("../../js/global");
	
	function appendBodyLayout() {
	    var toolsData = global.childToolMgrIns.getToolsInfoByTag();
//		console.log(toolsData);
	    appendToolView(toolsData['all'],$("#thirdApp"));
	}
	
	function appendToolView(datas, parent) {
	    if (!datas) return;
        if (typeof datas["diag"] != "object") return;
        
        var len = datas.length;		//画虚线使用
        var $div = $("<div>");
        $div.attr("class", "cover_menu_sort clearfix");

        var $div2 = $("<div>");
        $div2.attr("class", "cover_menu_row");

        for (var j in datas["diag"]) {	//目前仅需用toolsData['all']['diag']中的内容
            var $div2_t = $("<div>");
            $div2_t.attr("class", "cover_main_menu");
            $div2_t.attr("id", datas["diag"][j].name);
            $div2_t.click(function() {
				global.childToolMgrIns.startTool(this.id, function() {}); // 返回 true or false 进程关闭时 调用callback
                statRecordClick("toolkit#" + this.id);
            });
            
            $div2_t.hover(function() {
                $(this).css("background-color", "#e8eefc");
            }, function() {
                $(this).css("background-color", "#fff");
            });
            
            var img_url = datas["diag"][j].icon.replace(/\\/g, '\/');
            var img_style = 'url(' + img_url + ') no-repeat 16px center transparent';
            $div2_t.css("background", img_style);
            $div2_t.css("background-size", "38px 38px");

            var $div2_t_2 = $("<div>");
            $div2_t_2.attr("class", "cover_menu_text");
            var $div2_t_2_1 = $("<div>");
            $div2_t_2_1.attr("class", "cover_menu_title");
            $div2_t_2_1.html(datas["diag"][j].title);
            var $div2_t_2_2 = $("<div>");
            $div2_t_2_2.attr("class", "cover_menu_desc_text");
            $div2_t_2_2.attr("title", datas["diag"][j].description);
            $div2_t_2_2.html(datas["diag"][j].description);
            $div2_t_2.append($div2_t_2_1).append($div2_t_2_2);

            $div2_t.append($div2_t_2);
            $div2.append($div2_t);
        }
        --len;
        $div.append($div2);
        parent.append($div);
        if (len >= 1) {
            var $div_bl = $("<div>"); 
            $div_bl.attr("class", "interval_line");
            parent.append($div_bl);
        }
	}
	
	function init() {
		initPageStatistic();
		initEvent();
		initDom();
		resize();
		initGlobalEvent();
		
		function initPageStatistic() {
			statRecordEle("softCenter#softCenter");
		}
		function initEvent() {			
			global.restoreIns.on("restoreFail", function(res) {
				$("#restoringPassword").hide();
				$("#closeRestore").show();
				$("#restorePassword").show();
				
				alert(undefined, res);
			});
			
			global.restoreIns.on("restoreSuccess", function(res) {
				console.log(res);
				
				$("#restoringPassword").hide();
				$("#restorePassword").show();
				$("#closeRestore").show();				
//				$("#keyChange").hide();
//				$("#keyShow").show();
//				$("#keychangeShow").show();				
				
				alert(undefined, "密码恢复成功！");
			});
			
			$("#robot").click(function() {
				var gui = window.require('nw.gui');
				gui.Shell.openExternal("http://webchat.ruijie.com.cn/live800/chatClient/chatbox.jsp?companyID=8933&configID=17&enterurl=robot&live800_ud_invite=robot");
			});
			
			$("#factoryReset").click(function() {
				$("#keyChangeContent").hide();
				$("#factoryResetContent").show();
			});
			
			$("#keyChange").click(function() {
				$("#factoryResetContent").hide();
				$("#keyChangeContent").show();
			});
			
			$("#checkEnable").click(function() {
				if ($("#inputEnable").is(":visible")) {
					$("#inputEnable").hide();
				} else {
					$("#inputEnable").show();
				}
			});
			
			$("#checkTelnet").click(function() {
				if ($("#inputTelnet").is(":visible")) {
					$("#inputTelnet").hide();
				} else {
					$("#inputTelnet").show();
				}
			});
			
			$("#checkConsole").click(function() {
				if ($("#inputConsole").is(":visible")) {
					$("#inputConsole").hide();
				} else {
					$("#inputConsole").show();
				}
			});
			
			$("#restorePassword").click(function() {				
				function getComListCbk(res) {
					var params = {};
					params.restoreWay = null;
					params.password = {};
					params.comNum = res[0];
//					params.baudrate = "9600";
					
					var isFactoryReset = $("#factoryReset").is(':checked');
					var isKeyChange = $("#keyChange").is(':checked');

					if (!isFactoryReset && !isKeyChange) {
						alert(undefined, "请至少选择一种恢复方式！");
						return;
					}
					if (isFactoryReset) {
						params.restoreWay = "factoryReset";
						params.baudrate = $('#factoryResetBand option:selected').text();
					}					
					if (isKeyChange) {
						params.restoreWay = "keyChange";
						params.baudrate = $('#keyChangeBand option:selected').text();
						
						var isCheckEnable = $("#checkEnable").is(':checked');
						var isCheckTelnet = $("#checkTelnet").is(':checked');
						var isCheckConsole = $("#checkConsole").is(':checked');
						
						if (!isCheckEnable && !isCheckTelnet && !isCheckConsole) {
							alert(undefined, "请至少选择恢复一种密码！");
							return;
						}
						
						if (isCheckEnable) {
							var key_enable = $("#inputEnable").val();
							if (key_enable != "") {
								params.password.enable = key_enable;
							} else {
								alert(undefined, "请输入enable密码！");
								return;
							}										
						}
						if (isCheckTelnet) {
							var key_telnet = $("#inputTelnet").val();
							if (key_telnet != "") {
								params.password.Telnet = key_telnet;
							} else {
								alert(undefined, "请输入telnet/ssh密码！");
								return;					
							}							
						}
						if (isCheckConsole) {
							var key_console = $("#inputConsole").val();
							if (key_console != "") {
								params.password.console = key_console;
							} else {
								alert(undefined, "请输入console密码！");
								return;
							}							
						}
					}
					
					// 界面显示
					$("#closeRestore").hide();
					$("#restorePassword").hide();				
					$("#restoringPassword").show();
					
					global.restoreIns.restorePassword(params);
				}				
				global.restoreIns.getComList(getComListCbk);
			});
		}
		function initDom() {
			//第三方工具
			appendBodyLayout();
			
			//常用链接
			$(".link_menu").hover(function() {
                $(this).css("background-color", "#e8eefc");
            }, function() {
                $(this).css("background-color", "#fff");
            });
			
			$('#restoreModal').modal({
				backdrop: 'static',
				show: false
			});
		}
		function resize() {

		}
		function initGlobalEvent() {
			global.exitPageCallback.exitFun = function () {
				return true;
			}
		}
	}
	exports.init = init;
});