--[[
		-- 根据id获取信息
		lua_register(_lua, "lua_getInfoBySeq", lua_getInfoBySeq);
		-- 获取检测项id
		lua_register(_lua, "lua_getID", lua_getID);
		-- 设置检测结果
		lua_register(_lua, "lua_addResult", lua_addResult);
		-- 设置检测分数
		lua_register(_lua, "lua_addScore", lua_addScore);
		-- 设置提示；第一个参数为外部传入的DetectionLua类指针，第二个参数为简要提示；若有详细提示的需求(详细提示在生成的报告中显示)，请传入第三个参数；
		lua_register(_lua, "lua_addTip", lua_addTip);	
		-- 完成检测后调用
		lua_register(_lua, "lua_afterDetect", lua_afterDetect);
		-- 发送停止检测信号
		lua_register(_lua, "lua_fireStopDetectSignal", lua_fireStopDetectSignal);
		-- 获取设定的服务器ip
		lua_register(_lua, "lua_getWebIP", lua_getWebIP);
		-- 获取当前检测项所需信息的id
		lua_register(_lua, "lua_getRequiredInfoSeqs", lua_getRequiredInfoSeqs);
		-- 设置当前检测项所需信息的id
		lua_register(_lua, "lua_addRequiredInfoSeq", lua_addRequiredInfoSeq);
		-- 获取当前检测项的配置参数
		lua_register(_lua, "lua_getData", lua_getData);
		-- 版本对比
		lua_register(_lua, "lua_compareVer", lua_compareVer);
		-- 生成报告
		lua_register(_lua, "lua_detectReport", lua_detectReport);
		-- 写文件(utf8)
		lua_register(_lua, "lua_writeFileUTF8", lua_writeFileUTF8);
		-- 写文件
		lua_register(_lua, "lua_writeFile", lua_writeFile);
		-- 同网段判断
		lua_register(_lua, "lua_isSameSubnet", lua_isSameSubnet);
		-- 获取文件大小
		lua_register(_lua, "lua_getFileSize", lua_getFileSize);
		-- 判断是否可以ping通
		lua_register(_lua, "lua_getConnectState", lua_getConnectState);
		-- 移除检测项
		lua_register(_lua, "lua_removeDetection", lua_removeDetection);
		-- 获取app所在路径
		lua_register(_lua, "lua_getAppPath", lua_getAppPath);
		-- 提交log
		lua_register(_lua, "lua_uploadLog", lua_uploadLog);		
		-- 弹窗提示
		lua_register(_lua, "lua_alert", lua_alert);
		-- 获取检测分数
		lua_register(_lua, "lua_getScore", lua_getScore);
		-- 获取告警项数量
		lua_register(_lua, "lua_getWarningCount", lua_getWarningCount);
		-- 获取失败项数量
		lua_register(_lua, "lua_getFailedCount", lua_getFailedCount);
		-- 获取失败项id
		lua_register(_lua, "lua_getFailedIDs", lua_getFailedIDs);
		-- 获取告警项id
		lua_register(_lua, "lua_getWarningIDs", lua_getWarningIDs);
		-- 根据id获取检测项的描述
		lua_register(_lua, "lua_getDescByID", lua_getDescByID);
		-- 根据id获取提示
		lua_register(_lua, "lua_getTipByID", lua_getTipByID);
		-- 获取检测未通过的id
		lua_register(_lua, "lua_getNotPassIDs", lua_getNotPassIDs);
		-- 获取rule的版本
		lua_register(_lua, "lua_getRuleVersion", lua_getRuleVersion);
		-- 获取检测工具版本
		lua_register(_lua, "lua_getDetectVersion", lua_getDetectVersion);
		-- utf8 to char
		lua_register(_lua, "lua_UTF8ToChar", lua_UTF8ToChar);
		-- char to utf8
		lua_register(_lua, "lua_charToUTF8", lua_charToUTF8);

	enum DetectResult
	{
		DetectResult_unknow=0,
		DetectResult_pass=1,
		DetectResult_warning=2,
		DetectResult_failed=3,
		DetectResult_failedAndWarning=4,
		DetectResult_all=5
	};
]]
local generalFun = {}

local cjson = require "cjson"
local filePath = "detectionLog.txt"
local backup_filePath = "backup_detectionLog.txt"
local fileMode = "a+"
local infoDesc = {	
[1001]="获取box设置的教师机ip和云主机ip， size=扫描到的终端数量",
[3001]="是否能ping通云主机",
[3002]="获取guest-tool版本",
[3003]="获取cm-stu版本",
[3004]="获取镜像安装的黑名单软件列表",
[3005]="获取guest-tool D盘安装包版本",
[3006]="获取cm-stu D盘安装包版本",
[3007]="获取本机ip gateway",
[3008]="获取本机admin-tool版本", 
[0]="check server",
[1]="获取云桌面列表中的终端数量（云桌面总数）",
[2]="获取rcdos版本",
[3]="获取RCD本地部署模式",
[4]="获取上网地址",
[5]="获取两个物理网口地址",
[6]="获取DNS",
[7]="获取两个网卡IP",
[8]="获取网关",
[9]="RCD服务器两个物理网卡是否link为千兆",
[10]="RCD服务器两个物理网卡是否出现IP地址冲突",
[11]="获取客户信息表",
[13]="获取云桌面列表中终端信息",
[14]="获取RCD系统时间",
[15]="获取DHCP配置开启情况",
[16]="获取镜像分发服务开启情况",
[17]="获取教师机ip",
[18]="获取证书信息",
[19]="获取服务器运行时长",
[20]="获取cache目录使用百分比",
[21]="获取课程镜像空间使用百分比",
[22]="获取机械盘空间使用百分比",
[23]="获取共享目录大小",
[24]="获取从机ip",
[25]="获取所有云主机rcd sn",
[26]="查询基础版本号",
[27]="校验从机的共享目录是否同步",
[28]="获取镜像base文件大小",
[29]="获取作业空间服务器地址",
[30]="获取服务器admin-tool版本",
[31]="获取服务器作业空间版本",
[32]="获取设置自动重启情况",
[33]="获取服务器角色",
[34]="获取eccError"
}

local pThis = 0
function generalFun.setClassPointer(p)
	pThis = p
end

function generalFun.getClassPointer()
	return pThis
end

local schoolName = ''
function generalFun.setschoolName(name)
	schoolName = name
end

function generalFun.getschoolName()
	return schoolName
end

function generalFun.writeFileUTF8(content)
	local szdate=os.date("%Y-%m-%d %H:%M:%S")
	lua_writeFileUTF8(""..szdate.."::  "..content.."\n",filePath,fileMode)
end

function generalFun.writeFile(content)
	local szdate=os.date("%Y-%m-%d %H:%M:%S")
	lua_writeFile(""..szdate.."::  "..content.."\n",filePath,fileMode)
end

function generalFun.preparedLog()
	local fileSize = lua_getFileSize(filePath)
	if fileSize > 2*1024*1024 then
		os.remove(backup_filePath)
		local f = io.open("./"..filePath,"r")
		local content = f:read("*a")
		f:close()  		
		lua_writeFile(""..content.."\n",backup_filePath,fileMode)
		os.remove(filePath)		
	end
end

function generalFun.failedDection()
	local p = pThis
	lua_addResult(p,2)
	lua_addScore(p,-100)
	lua_addTip(p,"该项检测失败，服务器存在异常，请联系锐捷技术支持热线")
	lua_afterDetect(p)
	lua_fireStopDetectSignal(p)		
	lua_uploadLog("detectionLog.txt",GeneralFun.getschoolName())
	return false
end

function generalFun.getInfoBySeq(p,seq)
	local info = lua_getInfoBySeq(p,seq)
	generalFun.writeFileUTF8("info id:"..seq.."  info desc:"..infoDesc[seq])
	generalFun.writeFile("info result:\n"..info.."")
	if info == nil or string.len(info) == 0 or info == "null\n"  then
		generalFun.failedDection()
		return false
	end
	local value = cjson.decode(info)
	return value
end

function generalFun.addTip(p,tip)
	local file = assert(io.open("detectionTip.txt", "w+"))
	file:write(tip)
	lua_addTip(p,tip)
end


function generalFun.printSeqs(seqs)
	generalFun.writeFileUTF8('seqs size='..#seqs..' < ')	
	for i=1, #seqs do
		generalFun.writeFileUTF8(''..seqs[i]..' ')
	end
	generalFun.writeFileUTF8('>')
end

function generalFun.stringToTime(dateString)--2015-11-30 11:55:15
	return os.time({year=string.sub(dateString,1,4), month=string.sub(dateString,6,7), day=string.sub(dateString,9,10),
							    hour=string.sub(dateString,12,13),min=string.sub(dateString,15,16),sec=string.sub(dateString,18,19)})
end

function generalFun.getConfig()
	local file = io.open('data/rule/config.txt',"r")
	assert(file)
	local data = file:read("*a")
	
	local filePath = "detectionLog.txt"
	local fileMode = "a+"
	lua_writeFileUTF8("config:"..data.."\n",filePath,fileMode)
	file:close()
	local cjson = require "cjson"
	local value = cjson.decode(data)
	return value
end

function generalFun.stringSplit(str, split_char)
    local sub_str_tab = {};
    while (true) do
        local pos = string.find(str, split_char);
        if (not pos) then
            sub_str_tab[#sub_str_tab + 1] = str;
            break;
        end
        local sub_str = string.sub(str, 1, pos - 1);
        sub_str_tab[#sub_str_tab + 1] = sub_str;
        str = string.sub(str, pos + 1, #str);
    end
    return sub_str_tab;
end

 
return generalFun