
local detection = {}

local desc = '冗余配置检测'
local cjson = require "cjson"
local GeneralFun = require ('data/rule/detection/GeneralFun')

function detection.Detect()
	local webip = lua_getWebIP()
	local p = GeneralFun.getClassPointer()	
	GeneralFun.writeFileUTF8("== "..desc.." ==")
	local value = GeneralFun.getInfoBySeq(p,15)	if value == false then return end
	local dhcpStatus = value[webip]["dhcpStatus"]
	
	if string.lower(dhcpStatus) == "on" then
		lua_addResult(p,3)
		lua_addScore(p,-5)
		lua_addTip(p,"DHCP服务未关闭，请确认关闭DHCP服务")
	else
		lua_addResult(p,1)
	end
	
	local value = GeneralFun.getInfoBySeq(p,16)	if value == false then return end
	local pxeStatus = value[webip]["pxeStatus"]
	
	if string.lower(pxeStatus) == "on" then
		lua_addResult(p,3)
		lua_addScore(p,-10)
		lua_addTip(p,"部署完成后请关闭镜像分发服务，以免导致其他设备误刷")
	else
		lua_addResult(p,1)
	end
	
	lua_afterDetect(p)
end
 
return detection