
local detection = {}
 
local desc = '作业空间功能模块检测'
local cjson = require "cjson"
local GeneralFun = require ('data/rule/detection/GeneralFun')

function detection.Detect()
	local webip = lua_getWebIP()
	local p = GeneralFun.getClassPointer()
	GeneralFun.writeFileUTF8("== "..desc.." ==")
	local value = GeneralFun.getInfoBySeq(p,2)	if value == false then return end
	local rcdosVer = value[webip]["version"]		
	local value = GeneralFun.getInfoBySeq(p,31)		if value == false then return end
	local server_ver = value[webip]["version"]
	
	if string.len(server_ver) == 0 then
		lua_addResult(p,2)
		lua_addScore(p,0)
		lua_addTip(p,"服务器未安装作业空间组件，请确认是否需要安装")
	else
		local config = GeneralFun.getConfig()
		if config["workspaceVersion"][server_ver] == nil then
			lua_addResult(p,1)
		else		
			local maxVersion = config["workspaceVersion"][server_ver]["maxVersion"]
			local minVersion = config["workspaceVersion"][server_ver]["minVersion"]
			
			local ret1 = lua_compareVer(rcdosVer,minVersion)
			local ret2 = lua_compareVer(rcdosVer,maxVersion)
			
			if ret1 == 3 or ret2 == 2 then
			--1、检测到安装的作业空间版本与当前RCD对应的作业空间版本不一致，分数： - 10分
				lua_addResult(p,3)
				lua_addScore(p,-10)
				lua_addTip(p,"请升级作业空间功能组件")
			else
				lua_addResult(p,1)
			end
		end
		
		local value = GeneralFun.getInfoBySeq(p,29)	if value == false then return end
		local info = cjson.encode(value)
		local b = false
		if string.find(info,"workspaceIp") ~= nil then 
			value = cjson.decode(info)
			local workspaceIp = value[webip]["workspaceIp"]
			b = string.len(workspaceIp) ~= 0
		end
		if not b then
		--2、检测到作业空间服务器地址未配置，分数：-5分
			lua_addResult(p,3)
			lua_addScore(p,-5)
			lua_addTip(p,"未设置作业空间服务器地址")
		else
			lua_addResult(p,1)			
		end
	end
	
	lua_afterDetect(p)		
end
 
return detection