
local detection = {}
 
local desc = '证书加载检测'
local cjson = require "cjson"
local GeneralFun = require ('data/rule/detection/GeneralFun')

function detection.Detect()
	local webip = lua_getWebIP()
	local p = GeneralFun.getClassPointer()
	GeneralFun.writeFileUTF8("== "..desc.." ==")
	-- 证书加载检测
	local value = GeneralFun.getInfoBySeq(p,18)	if value == false then return end
	local license = value[webip]["license"]
	if license == "on" then
		lua_addResult(p,1)	
	else
		lua_addResult(p,3)
		lua_addScore(p,-10)
		lua_addTip(p,"目前云主机未导入正式授权，请在试用期内导入正式授权，以免影响云课堂正常使用")
	end
	-- rcd sn
	
	local value = GeneralFun.getInfoBySeq(p,7)		if value == false then return end
	local ip = value[webip]["ip"]
	local ip2 = value[webip]["ip2"]
	
	local value = GeneralFun.getInfoBySeq(p,25)		if value == false then return end
	local rcdsn = ""
	local slavercdsn = ""
	local hostSn = value[webip]["hostSn"]	
	for k,v in pairs(hostSn) do
		for tmp_ip,tmp_rcdsn in pairs(v) do
			if tmp_ip == webip or tmp_ip == ip or tmp_ip == ip2 then
				rcdsn = tmp_rcdsn
			else
				if string.len(slavercdsn) ~= 0 then
					slavercdsn = slavercdsn .. "\\"
				end
				slavercdsn = slavercdsn .. tmp_rcdsn
			end		
		end
	end
	
	rcdsn = string.len(rcdsn)~=0 and rcdsn or "NA"	
	
	if rcdsn == "NA" then
		lua_addResult(p,3)
		lua_addScore(p,-100)
		lua_addTip(p,"服务器存在异常，无法读取硬件码信息，请联系锐捷技术支持")
		
		lua_afterDetect(p)
		lua_fireStopDetectSignal(p)
		return
	else
		lua_addResult(p,1)
	end
	
	lua_afterDetect(p)
end
 
return detection