
local detection = {}
 
local desc = '检测系统运行时长'
local cjson = require "cjson"
local GeneralFun = require ('data/rule/detection/GeneralFun')

function detection.Detect()
	local webip = lua_getWebIP()
	local p = GeneralFun.getClassPointer()
	GeneralFun.writeFileUTF8("== "..desc.." ==")
	
	local value = GeneralFun.getInfoBySeq(p,32)	if value == false then return end
	local bSet = string.lower(value[webip]["rebootSchedule"]) == "y"	
	
	local value = GeneralFun.getInfoBySeq(p,19)	if value == false then return end
	local runTime = value[webip]["runTime"]		
	runTime = string.sub(runTime,1,string.len(runTime)-1)
	local m = tonumber(runTime)

	if bSet ~= true and m>24*60 then
		lua_addResult(p,3)
		lua_addScore(p,-5)
		lua_addTip(p,"服务器长时间运行，请设置定时重启功能")
	else
		lua_addResult(p,1)
	end
	
	lua_afterDetect(p)
end
 
return detection