
local detection = {}

local desc = '系统空间检测'
local cjson = require "cjson"
local GeneralFun = require ('data/rule/detection/GeneralFun')
 
function detection.Detect()
	local webip = lua_getWebIP()
	local p = GeneralFun.getClassPointer()
	GeneralFun.writeFileUTF8("== "..desc.." ==")
	
	local value = GeneralFun.getInfoBySeq(p,20)	if value == false then return end
	local percent = value[webip]["percent"]
	local per = tonumber(string.sub(percent,0,string.len(percent)-1))
	if per > 95 then
			lua_addResult(p,3)
			lua_addScore(p,-5)
			lua_addTip(p,"请检测是否镜像是否开启存储模式，并确定删除无用的差分文件")
	else
		lua_addResult(p,1)
	end
	
	local value = GeneralFun.getInfoBySeq(p,21)	if value == false then return end
	percent = value[webip]["percent"]
	per = tonumber(string.sub(percent,0,string.len(percent)-1))
	if per > 98 then
		lua_addResult(p,3)
		lua_addScore(p,-3)
		lua_addTip(p,"课程镜像空间接近上限，请检测是否需要备份并删除无用课程镜像")
	elseif per > 90 then
		lua_addResult(p,2)
		lua_addScore(p,0)
		lua_addTip(p,"课程镜像空间接近上限，请检测是否需要备份并删除无用课程镜像")
	else
		lua_addResult(p,1)
	end
		
	local value = GeneralFun.getInfoBySeq(p,22)	if value == false then return end
	percent = value[webip]["percent"]
	per = tonumber(string.sub(percent,0,string.len(percent)-1))
	if per > 90 then
		lua_addResult(p,3)
		lua_addScore(p,-5)
		lua_addTip(p,"云主机硬盘空间接近上限，请检测教师共享目录/学生共享目录，删除其中无用文件")
	else
		lua_addResult(p,1)
	end
		
	local value = GeneralFun.getInfoBySeq(p,23)	if value == false then return end
	percent = value[webip]["percent"]
	per = tonumber(string.sub(percent,0,string.len(percent)-1))
	if per > 83 then
		lua_addResult(p,3)
		lua_addScore(p,-5)
		lua_addTip(p,"共享目录大小接近上限，请删除共享目录中无用文件")
	else
		lua_addResult(p,1)
	end
	
	lua_afterDetect(p)		
end
 
return detection