
local detection = {}
 
local desc = 'RCD组件软件是否升级与RCDOS对应版本'
local cjson = require "cjson"
local GeneralFun = require ('data/rule/detection/GeneralFun')

function detection.Detect()
	local webip = lua_getWebIP()
	local p = GeneralFun.getClassPointer()
	GeneralFun.writeFileUTF8("== "..desc.." ==")
	
	local value = GeneralFun.getInfoBySeq(p,3002)	if value == false then return end
	local gtVer = value["version"]	
	local value = GeneralFun.getInfoBySeq(p,3003)	if value == false then return end
	local cmVer = value["version"]	
	local value = GeneralFun.getInfoBySeq(p,3005)	if value == false then return end
	local gtVer_package = value["version"]	
	local value = GeneralFun.getInfoBySeq(p,3006)	if value == false then return end
	local cmVer_package = value["version"]	
	
	local iResult = 0
	if gtVer == "0.0.0.0" then iResult = 1 end	--未安装
	if iResult == 0 and string.len(gtVer_package) == 0 then iResult = 2 end --未找到安装包
	if iResult == 0 and lua_compareVer(p,gtVer,gtVer_package) ~= 1 then iResult = 3 end --版本不同
	
	if iResult == 0 then
		lua_addResult(p,1)
	elseif iResult == 1 then		
		lua_addResult(p,3)
		lua_addScore(p,-20)
		lua_addTip(p,"请安装guest-tool工具，可在D盘手动安装")
	elseif iResult == 2 then		
		lua_addResult(p,3)
		lua_addScore(p,-20)
		lua_addTip(p,"D盘guest-tool安装文件不存在")
	elseif iResult == 3 then		
		lua_addResult(p,3)
		lua_addScore(p,-20)
		lua_addTip(p,"请升级guest-tool工具，可在D盘手动升级")
	end
		
	iResult = 0
	if cmVer == "0.0.0.0" then iResult = 1 end	--未安装
	if iResult == 0 and string.len(cmVer_package) == 0 then iResult = 2 end --未找到安装包
	if iResult == 0 and lua_compareVer(p,cmVer,cmVer_package) ~= 1 then iResult = 3 end --版本不同
	
	if iResult == 0 then
		lua_addResult(p,1)
	elseif iResult == 1 then		
		lua_addResult(p,3)
		lua_addScore(p,-20)
		lua_addTip(p,"请安装ClassManager_Student工具，可在D盘手动安装")
	elseif iResult == 2 then		
		lua_addResult(p,3)
		lua_addScore(p,-20)
		lua_addTip(p,"D盘ClassManager_Student安装文件不存在")
	elseif iResult == 3 then		
		lua_addResult(p,3)
		lua_addScore(p,-20)
		lua_addTip(p,"请升级ClassManager_Student工具，可在D盘手动升级")
	end
	
	lua_afterDetect(p)
end
 
return detection