
local detection = {}

local desc = '云主机设备发现'
local cjson = require "cjson"
local GeneralFun = require ('data/rule/detection/GeneralFun')
 
function detection.Detect()
	local webip = lua_getWebIP()
	local p = GeneralFun.getClassPointer()
	GeneralFun.writeFileUTF8("== "..desc.." ==")
	
	local seqs = {lua_getRequiredInfoSeqs(p)}	
	if #seqs == 1 then		
	
		local value = GeneralFun.getInfoBySeq(p,3001)	if value == false then return end	
		if not value["result"] then
			lua_addResult(p,3)
			lua_addScore(p,-100)
			lua_addTip(p,"无法连接云主机，请确认体检云主机IP是否配置正确")
			
			lua_afterDetect(p)
			lua_fireStopDetectSignal(p)
			return
		else
			lua_addResult(p,1)
		end	
	
		local jsonRoot = {}
		jsonRoot[1]={}
		jsonRoot[1]['id']=0
		jsonRoot[1]['content']=''
		jsonRoot[2]={}
		jsonRoot[2]['id']=3001
		jsonRoot[2]['content']=''
		jsonRoot[3]={}
		jsonRoot[3]['id']=11
		jsonRoot[3]['content']=''
		local jsonStr = cjson.encode(jsonRoot)
		lua_addRequiredInfoSeq(p,jsonStr)
		
		return
	end
	
	local value = GeneralFun.getInfoBySeq(p,11)	if value == false then return end	
	local name = value[webip]["name"]
	GeneralFun.setschoolName(string.len(name)~=0 and name or "NA")
	
	local info = lua_getInfoBySeq(p,0)
	if info == nil or string.len(info) == 0 or info == "null\n"  then
		local tip = "已修复云主机异常，云主机正在重启，请稍后……"
		lua_addResult(p,3)
		lua_addScore(p,-100)
		lua_addTip(p,tip)
	
		lua_afterDetect(p)
		lua_fireStopDetectSignal(p)
		lua_alert(tip)
		return
	end
	
	local value = GeneralFun.getInfoBySeq(p,0)	if value == false then return end
	local state = string.lower(value[webip]["needReboot"])
	if state ~= "no" then
		local tip = "已修复云主机异常，云主机正在重启，请稍后……"
		lua_addResult(p,3)
		lua_addScore(p,-100)
		lua_addTip(p,tip)
	
		lua_afterDetect(p)
		lua_fireStopDetectSignal(p)
		lua_alert(tip)
		return
	else
		lua_addResult(p,1)
	end			
	
	lua_afterDetect(p)	
end
 
return detection