
local detection = {}

local desc = '云主机硬件检测'
local cjson = require "cjson"
local GeneralFun = require ('data/rule/detection/GeneralFun')

function detection.Detect()
	local webip = lua_getWebIP()
	local p = GeneralFun.getClassPointer()
	GeneralFun.writeFileUTF8("== "..desc.." ==")
		
	local value = GeneralFun.getInfoBySeq(p,34)		if value == false then return end
	local eccError = string.lower(value[webip]["eccError"])
	
	if eccError == "no" then
		lua_addResult(p,1)		
	elseif eccError == "yes" then
		local amount = value[webip]["amount"]
		local firstTime = value[webip]["firstTime"]
		local lastTime = value[webip]["lastTime"]
		lua_addTip(p,"从"..firstTime.."到"..lastTime.."，出现"..amount.."次ECC内存错误告警，请联系锐捷远程技术支持热线")
		lua_addScore(p,-5)
		lua_addResult(p,2)
	else
		GeneralFun.failedDection()
	end
		
	lua_afterDetect(p)	
end
 
return detection