
local detection = {}
 
local desc = '云终端设备发现'
local cjson = require "cjson"
local GeneralFun = require ('data/rule/detection/GeneralFun')

function detection.Detect()
	local webip = lua_getWebIP()
	local p = GeneralFun.getClassPointer()
	GeneralFun.writeFileUTF8("== "..desc.." ==")
	
	local seqs = {lua_getRequiredInfoSeqs(p)}
	GeneralFun.printSeqs(seqs)	
	if #seqs == 1 then	
		local value = GeneralFun.getInfoBySeq(p,13)		if value == false then return end
		local boxSize = #value[webip]
		
		if boxSize == 0 then
			lua_addTip(p,"未配置云桌面，请检查云桌面配置情况")
			lua_addResult(p,2)
			lua_addScore(p,0)
			lua_afterDetect(p)
			return
		end
		
		local bRelation = false
		local macs = ''			
		for i=1,boxSize do
			if string.len(macs) > 0 then macs = macs .. ',' end
			macs = macs .. value[webip][i]['tmMac']
			if string.len(value[webip][i]['tmIp']) ~= 0 then bRelation = true end
		end			
		
		if not bRelation then 
			lua_addTip(p,"云课堂未关联任何云终端，请确认云课堂部署情况")
			lua_addResult(p,2)
			lua_addScore(p,0)
			lua_afterDetect(p)
		else
			local jsonRoot = {}
			jsonRoot[1]={}
			jsonRoot[1]['id']=1
			jsonRoot[1]['content']=''
			jsonRoot[2]={}
			jsonRoot[2]['id']=1001
			jsonRoot[2]['content']=macs
			local jsonStr = cjson.encode(jsonRoot)
			lua_addRequiredInfoSeq(p,jsonStr)
		end			
		return
	end
	
	local value = GeneralFun.getInfoBySeq(p,1001)	if value == false then return end
	local box_count = value["box_count"]
	local value = GeneralFun.getInfoBySeq(p,1)	if value == false then return end
	local count = tonumber(value[webip]["tmAmount"])
	local szBoxCount = tostring(box_count)
	if string.len(szBoxCount) > 2 then
		szBoxCount = string.sub(szBoxCount,1,string.len(szBoxCount)-2)
	end
		
	if box_count ~= count then
		lua_addTip(p,"当前扫描的CM-BOX端数量为："..szBoxCount.."，与云桌面列表中的终端数不一致，请确认是否开启全部云终端或踢出已无用云终端")
		lua_addResult(p,3)
		lua_addScore(p,-5)
	else
		lua_addResult(p,1)
	end
	
	lua_afterDetect(p)		
end
 
return detection