
local detection = {}

local desc = 'RCDOS版本检测'
local cjson = require "cjson"
local GeneralFun = require ('data/rule/detection/GeneralFun')

function detection.Detect()
	local webip = lua_getWebIP()
	local p = GeneralFun.getClassPointer()
	GeneralFun.writeFileUTF8("== "..desc.." ==")
		
	local config = GeneralFun.getConfig()
	local ver1 = config["rcdosVersion"]["lowest version"]
	local ver2 = config["rcdosVersion"]['latest version']	
	GeneralFun.writeFileUTF8('lowest version:'..ver1..'  latest version:'..ver2.." ")
	
	local bQuit = false
	local value = GeneralFun.getInfoBySeq(p,2)		if value == false then return end
	local rcdosVer = value[webip]["version"]
	local ret1 = lua_compareVer(rcdosVer,ver1) 
	local ret2 = lua_compareVer(rcdosVer,ver2) 
	
	if ret1 == 3 then
		--1、检测为v1.0.9和V1.1版本，结束体检，并提示1
		--lua_addTip(p,"版本过低，存在较大风险，请升级到最新版本")
		lua_addTip(p,"版本过低，存在较大风险，请升级到"..ver2.."及以上版本")
		lua_addScore(p,-100)
		lua_addResult(p,3)
		bQuit = true
	elseif ret2 == 3 or ret2 == 4 then
		--2、检测为V2.0.3.25以下版本，分数： - 5分
		lua_addTip(p,"当前版本是"..rcdosVer.."，建议升级到"..ver2.."及以上版本")
		lua_addScore(p,-5)
		lua_addResult(p,3)
	else
		lua_addResult(p,1)
	end
	
	lua_afterDetect(p)
	
	if bQuit then
		lua_fireStopDetectSignal(p)
	end
end
 
return detection