
local detection = {}

local desc = 'RCD系统时间检测'
local cjson = require "cjson"
local GeneralFun = require ('data/rule/detection/GeneralFun')

function detection.Detect()
	local webip = lua_getWebIP()
	local p = GeneralFun.getClassPointer()
	GeneralFun.writeFileUTF8("== "..desc.." ==")
	local value = GeneralFun.getInfoBySeq(p,14)	if value == false then return end
	local serverTime = value[webip]["time"]
	local localTime = os.date("%Y-%m-%d %H:%M:%S")
	local math = require "math"
	local span = math.abs(GeneralFun.stringToTime(serverTime)-GeneralFun.stringToTime(localTime))
	if span > 5*60 then
		lua_addResult(p,3)
		lua_addScore(p,-5)
		lua_addTip(p,"RCD服务器系统时间与检测设备时间不一致，请确认当前RCD服务器系统时间配置正确")
	else
		lua_addResult(p,1)
	end
	
	lua_afterDetect(p)
end
 
return detection